# ****************************************************************************
# Surgeweb javascript - Primary Surgeweb javascript code
# supported by:
#	- sw_ui.js			: User interface handler functions		
#	- sw_core.js 		: Core "webmail" logic / server io code
# 	- sw_windowing.js	: Windowing / layout and display reformatting
#	- sw_util.js		: Utility functions
#	- sw_betapane.js	: Various things that should not be in the final product
#	+ a whole lot of supporting self contained javascript modules 
#   note: all files are optimised into a single compressed download "combined.js"
# ----------------------------------------------------------------------------
#  - Application initialisation
#  - Popup window only funcitons
#  - Various bits left over from development that still need tidying
# ****************************************************************************


dbg("surgweb js loaded");

# Webmail client logic
var enMSG=1, enFLD=2;

#Global surgeweb object for storage of mailclient level info
var sw = new Object;

# Primary Surgeweb "application intialisation" called after "interface outline" page is
# loaded but has not been populated with any user data yet.
function do_init()
{
	dbg('primary application init function');
	browser_id();
	ajax_init();
	prefs_validate();
	extend_init(1);
	column3_init();

	panelise();
	cache_dom_nodes();
	menubar_init('menu_bar_main');
	window_manager_init();
	app_menu_init();
	beta_testers_init();
	info_panel_init();
	sizers_init();
	extend_init(2);
	init_ui_elements()
#	// This does first and primary resize
	do_layout();
#	// This intentionally goes through timer (else eg sizers do not get correctly placed sometimes)
	do_resize();
	background_init();
	do_init_data();
	events_init();
	tweak_unfinished_stuff();
	touch(1);
	check_new_timed();
	xmenu_init();
	misc_init();
	bookmarking_init();
	compat_warn();
#	alert(get_cookie('SW-AUTHTOKEN'));
}


function prefs_validate()
{
	if (!pref.mode) pref.mode='app';
	if (!pref.preview) pref.preview=(pref.mode=='app'?'vert':'none');
	if (!pref.windows) pref.windows=(pref.mode=='app'?'popup':'inline');
	if (!pref.sounds) pref.sounds='all'; 	//pref_sounds
#	pref['confirm_no_ndelete']=false;
	sw.sort_type='date';
	sw.sort_rev='true';
	sw.ajax=true;
	sort_init(pref.sort_order,pref.sort_rev);	
}


function cache_dom_nodes()
{
	sw.msgs_pane=document.getElementById("messages"); //get_panel_node("messages","outer");
	sw.msgs_panelist=document.getElementById("messages_list");
	sw.msgs_preview=document.getElementById("message_preview");
#	sw.msg_pane=document.getElementById("message");

	sw.util=document.getElementById("utility");
	
	sw.menubar=document.getElementById("menubar");
	
	sw.search_input=document.getElementById("search_input");
	sw.search_limit=document.getElementById("search_limit");
	
	sw.status=document.getElementById("status");
	sw.busy=document.getElementById("busy");
}


function do_init_data()
{
	var extra='&tz='+(-((new Date()).getTimezoneOffset())/60*100);
	sw.fld_type=1;
	sw.fld_id='INBOX';
	if(initial_folder.fld_id.length>0){
		sw.fld_id=initial_folder.fld_id;
		sw.fid=initial_folder.fid;
	}
	if(disable_markread_fld){
		extra+='&disable_markread='+disable_markread_fld;
	}
	sndReq('cmd=show&page=~login.js&fld_id='+sw.fld_id+extra+'&sort='+sw.sort_type+'&rev='+sw.sort_rev, function(chan){
		actionReqJs(chan);
		switch_selfld(sw.fld_id);
		hide_loading();
		if(isChrome3 && sw.dnd_disabled==undefined) return;
		msgdnd_init();
	});
}

function events_init()
{
	document.onkeydown=global_keydown;
	document.onkeyup=global_keyup;
#	dge("messages").onkeydown=msglist_keydown;
#	dge("messages").onkeyup=msglist_keyup;
	dbg('REG KEYDOWN *************')
	dge("message_preview").onkeydown=preview_keydown;
	
}
function global_keydown(e)
{
	dbg('document onkeydown'); // KBC: global 
	var ret=true;
	var last_mid;
	if (!e) e = window.event;
	if (!e) return;
	touch(2);
# 	Keycode identification code
#	if (true){
	dbg("keycode="+e.keyCode+" shiftKey="+e.shiftKey+" ctrlKey="+e.ctrlKey+" altKey="+e.altKey+" metaKey="+e.metaKey );
#		stop_def_action(e);
#		return false;
#	}

	if (!sw.active) return;

	if (false /*&& modal_dialog()*/) return;

	if(!isMac && (e.metaKey||e.altKey) && !e.ctrlKey) return;

#	if (e.shiftKey==true && class_contains(sw.active,'fldmsg')){
#	Chrome 1.0 returns metakey on altKey!!
	var metakey=e.metaKey && !e.altKey;
	if (pref.mode=='app' && class_contains(sw.active,'fldmsg')/*&&!metakey*/ ){
		ret = msglist_keydown(e)
	}else{
		ret = msgmenu_keydown(e);
	}

	return ret;
}

var vkUpArrow=38, vkDownArrow=40, vkLeftArrow=37, vkRightArrow=39, vkPgUp=33, vkPgDown=34, vkEnter=13, vkDelete=8, vkBspDel=46, vkEsc=27, vkEquals=187,
	vkA=65,vkF=70,vkG=71,vkL=76,vkM=77,vkN=78,vkQ=81,vkR=82,vkS=83,vkZ=90,
	vk1=49,vk2=50,vk3=51,vk4=52,vk5=53,vk6=54;

function msglist_keydown(e)
{
	var ret=true;
	switch (e.keyCode){
	case vkUpArrow:
#			 debugger
			 if (e.ctrlKey&&(e.altKey||e.metaKey)){
				pref.message_done_action='prev';
#				stop_def_action(e);
				return ret;
			 }
			 if (e.shiftKey) {
				 if(cursor_row) row_select(cursor_row,true);				 	 
				 sw.b4select=false;
				 last_mid=cursor_mid;
			 }else{
				 select_none_fast();
			 }
			 var next_mid=show_prev_real(cursor_mid,false);
			 show_soon(next_mid,e.shiftKey);
			 if(e.shiftKey && sw.b4select && next_mid!=last_mid){
				row_unselect(sel_to_row(dge('sel_'+last_mid)));	
			 }
			 ret=false;
#			 shift_sel_start=null;
			 break;
	case vkDownArrow:
			if (e.ctrlKey&&(e.altKey||e.metaKey)){
				pref.message_done_action='next';
				return ret;
			 }
			 if (e.shiftKey) {
				 if(cursor_row) row_select(cursor_row,true);				 	 
				 sw.b4select=false;
				 last_mid=cursor_mid;
			 }else{
				select_none_fast();
			 }
			 var next_mid=show_next_real(cursor_mid,false);
			 show_soon(next_mid,e.shiftKey);
			 if(e.shiftKey && sw.b4select && next_mid!=last_mid)
				row_unselect(sel_to_row(dge('sel_'+last_mid)));	
			 ret=false;
#			 shift_sel_start=null;
			 break;

#	case vkUpArrow:
#			 if(sw.util.fldmsg_current==enMSG)
#				layout_fldmsg(enFLD);
#			 break;	

#	r / Ctrl+R - reply
	case vkR: 
			if(e.metaKey) break;
			do_reply(e);
			ret=false;
			break;
#	f - forward
#	Ctl+Shift+F - quick search					
	case vkF: if (!e.ctrlKey) {do_forward(e);ret=false;}
			if (e.ctrlKey && e.shiftKey) {dge('search_input').focus();ret=false;}
			break;
#	G - forward attach
	case vkG: 
			if(e.metaKey) break;
			do_forward_attach(e);
			ret=false;
			break;
#	Ctl+s - search					
	case vkS: 
			if (e.ctrlKey) {dge('search_input').focus();ret=false;}
			break;
||ifndef||labels_disable||
#	l - Label message
	case vkL:
			labels_menu(e,'kbd');
			break;
||endif||
#	n - Compose new message
	case vkN: 
			if (!e.ctrlKey) {do_compose(e);ret=false;}
			break;

#	q - quick search (or / or Ctl+Shift+F)
	case vkQ:
	case 191:
			if(ctl_cmd_key(e)) return ret;
			search_init(undefined,'quick');
			dge('search_input').focus();
			ret=false;
			break;

#	ctl A - disable default select all 
	case vkA: 
			 if (ctl_cmd_key(e)) {
				 if (e.shiftKey)
					 do_select('none');
				 else
					 do_select('all');
#				stop_def_action(e);
				return false;
			 }else{
				do_reply_all(e);
			 }
			 break;
	case vkEsc:
			 do_select('none');
			 msglist_unsearch();
			 search_init(undefined,pref.search_type);
			 if(cursor_row) row_select(cursor_row);
			 break;

#	M - Move message
	case vkM: 
			 if(ctl_cmd_key(e)) return ret;
			 move_menu(e,'kbd');
			 break;

#	ctl Z - Cache messages
	case vkZ: 
			 if (ctl_cmd_key(e)) {
				 if (e.shiftKey){
					 do_select('all');
					 do_cache();
					 do_select('none');
					 msglist_select(cursor_mid);
				 }else{
					do_cache();
				 }
			 }
			 break;

#	enter - show message (in keydown as keyup received after pressing enter on a dialog)
	case vkEnter:
			if (cursor_mid){
				show_msg(cursor_mid,e);	
			}
			break;	

#	Stop OSX Delete / backspace based back browsing
	case vkDelete: 
	case vkBspDel:
			stop_def_action(e);
			ret=false;
			break;

#	ctl shift 1-6 - single keystroke filing
	case vk1:		 
	case vk2:		 
	case vk3:		 
	case vk4:		 
	case vk5:		 
	case vk6:
			if(!(e.shiftKey&&e.ctrlKey)) break;
			var fld=keymap[e.keyCode-48];
			if(fld && fld.length>0)do_move_actual(fld);
			break;

	}
	
	return ret;
}

function global_keyup(e)
{
	var ret=true;
	if (!e) e = window.event;
	if (!sw.active) return;
	if (pref.mode=='app' && class_contains(sw.active,'fldmsg')){
		switch (e.keyCode){
#		delete / backspace - delete message(s)
		case vkDelete:
		case vkBspDel: 
				do_delete(e.shiftKey);
				ret=false;
				stop_def_action(e)
				break;
		case vkEquals:
				if(any_modifier(e)) break;
				do_move_actual('Done');
				break;
		}			
	}
	return ret;
}
function preview_keydown(e)
{
	var ret=true;
	if (!e) e = window.event;
	if (!sw.active) return;
	
	if (pref.mode=='app' && class_contains(sw.active,'fldmsg')){
		switch (e.keyCode){
#		delete / backspace - delete message(s)
		case vkA:
				 select_el(preview_to_body(dge("message_preview")));
				 ret=false;
				 stop_def_action(e)
				 break;
#		esc - select none
#		case 27: 
#				 do_select('none');
#				 break;
		}			
	}
	return ret;
}



function msgmenu_keydown(e)
{		
	dbg('msgmenu onkeydown'); // KBC: msgmenu 
#	if('message window' check) - not ideal but this will do for now
	if (!sw.menubar.current) return;
	var isMessage=(sw.menubar.current.id=="menu_message");
	var isEdit=(sw.menubar.current.id=="menu_compose");

	if(isEdit) {
		switch (e.keyCode){
#		escape:
		case 27: 
				if(sw.active.unsaved){
					edit_discard();
					break;
				}
				if (sw.active.tab_ref)
					tab_close(sw.active.tab_ref.id);
				break;
#		Enter
		case 13: 
				if (e.ctrlKey && e.shiftKey)
					do_send();
				if (e.ctrlKey && e.altKey)						
					do_send_move(e);
				break;
#		Ctrl+S - save draft
		case 83: if (e.ctrlKey){
					do_save_draft(undefined,function(){sw.active.unsaved=false});
				}
				break;
		}		
	}

	if(isMessage) {
		switch (e.keyCode){
#		escape:
		case 27: 
				if (sw.active.tab_ref)
					tab_close(sw.active.tab_ref.id);
				break;

#		r / Ctrl+R - reply
		case 82: 
				do_reply(e);
				break;
#		f - forward
		case 70: if (!e.ctrlKey) do_forward(e);
				break;
#		a - reply all
		case 65: 
				 if (!ctl_cmd_key(e)) do_reply_all(e);
				 break;
#		Ctrl+up arrow - prev message
		case 38: 
				 if (e.ctrlKey) show_prev(sw.is_popup?sw.mid:cursor_mid);
				 break;
#		Ctrl+down - next message
		case 40: 
				 if (e.ctrlKey) show_next(sw.is_popup?sw.mid:cursor_mid);
				 break;
		}
	}
}

function editor_keypress(e){
	if (!e) e = ew.event;
#	dbg("keypress in editor window - code="+e.keyCode);		// NOKEYS!!
#	alert(e.keyCode)
	switch (e.keyCode){
#		Enter
		case 13:
				if(quote_breakout()){
					stopEvent(e);
					return false;				
				}
#				stopEvent(e);
#				return false;
				break;
	}
}

function editor_keydown(e){
	if (!e) e = ew.event;
#	dbg("keydown in editor window - code="+e.keyCode);			// NOKEYS!!
	switch (e.keyCode){
#		Enter
		case 13: 
#				quote_breakout(e);
				break;
#	Make tab in editor indent text / move to subject edit field
		case 9:
				if (e.shiftKey){
					sw.active.field_subject.focus();
				}else{
					if(isIE){
						var xwin=get_edit_win();
						var sel = xwin.document.selection.createRange();
						sel.pasteHTML('&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;');
					}else if(isSafari){
#						//Safari on OSX must not stop this event!! 
						return;
					}else{
#						editor_do('insertHTML','<span class=\"tab-span\" style="white-space:pre">&#0009;</span>');
						editor_do('insertHTML','&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;');
					}	
				}
				stopEvent(e);
				return false;
				break;
	}
}
var qq=false;
function editor_keyup(e){
	if (!e) e = ew.event;

#	dbg("keyup in editor window - code="+e.keyCode);			// NOKEYS!!
	touch(4);
	switch (e.keyCode){
#		Enter
		case 13: 
				spellcheck_markup_removeall();
				if (e.ctrlKey && e.shiftKey)
					do_send();
				if (e.ctrlKey && e.altKey)						
					do_send_move(e);
#				quote_breakout();
				break;
#		Escape
		case 27: 
#					Grab focus back from iframe and then discard
				window.focus();
				edit_discard();
				break;

#		shift tab
#		case 9:
#				if (e.shiftKey){
#						window.focus();
#					sw.active.field_subject.focus();
#				}else{
#					dbg("*** tab in editor");
#				}
#				break;
#		Ctrl+S - save draft
		case 83: if (e.ctrlKey){
					do_save_draft(undefined,function(){sw.active.unsaved=false});
				}
				break;

#		space character
#		case 32:
#				spellcheck_markup_remove(e);
#				drop through to default				
		default:
#				clear_spellcheck_squiggle(e);
#				dbg('** default unsaved='+sw.active.unsaved)
				sw.active.unsaved=true;
				if(!autosave_timer){
					dbg('** starting autosave timer')
					autosave_timer=setTimeout(draft_autosave,(pref.devt_mode?4:120)*1000);
				}
				break;
	}
//		updateTimer();
}		

var autosave_timer;
function draft_autosave()
{
	autosave_timer=null;
	if(sw.menubar.current.id!="menu_compose") return;
	if(sw.active.unsaved){
		do_save_draft(true,function(){sw.active.unsaved=false});
	}
}



function popup_keydown(e)
{
	if (!e) e = window.event;
	if (!e) return;
	msgmenu_keydown(e);

#	dbg("keycode="+e.keyCode);		// NOKEYS!!
}
var ignore_one_hide=false;
document.onclick=function(e){
	if (!e) e = window.event
	if (!e) return;

	
#	t=target(e);
#	debugger;	// *Q*
	dbg('*Q* document.onclick hide='+ignore_one_hide)
#	if(class_contains(t,'shadow')) return;
	if (global_active_menu){
		if(ignore_one_hide){
			ignore_one_hide=false;
			return;
		}
		dbg('ONCLICK DOCUMENT hiding menu')
		menu_hide2(global_active_menu);
	}

	var t = target(e);
	if (t.tagName=="A"){
		dbg('clicked on link id='+t.id+' href='+t.href);

//		stopEvent(e);

		return;
		if (t.href.substring(0,7)=="http://" && !confirm("This links to an external page. Any unsaved data will be lost. Are you sure?")){
			return stopEvent(e);
		}
	}
}

function edit_subject_keydown(e)
{
	switch (e.keyCode){
#	enter - eat enter keys to prevent default form actions in edit fields
	case 13:
			focus_next_surgeweb_edit_ctl(target(e));
			stopEvent(e);
			return false;
			break;	
	}
}

# ***** Functions for use from popup msg / edit window only *****

function do_popup_init()
{
	sw_win = window.opener;
#	// Make sure that the object in or calling window has been instanciated
	var pp=sw_win.pending_popups[window];
	if (!pp){
		setTimeout(do_popup_init,20);
		return;
	}

	dbg('attaching debug output to main window for central logging');
	dbg=sw_win.dbg;
	dbg('*** POPUP message window attached ***');
	
	browser_id();

	sw.util=document.getElementById("utility");
	sw.menubar=document.getElementById("menubar");

	var container=document.getElementById('message_container');
	container.popup_message=document.getElementById('message_panel');
	container.popup_compose=document.getElementById('compose_panel');
	container.popup_message.container=container.popup_compose.container=container;

	sw.active=container.popup_message;

	if ('||panel_mode||'=='orig_x'){
		panelise_roundtop(document.getElementById('menubar'),enHdr);
		panelise_square(container.popup_message,enBody3);
		panelise_square(container.popup_compose,enBody3);
		panelise_square(document.getElementById('sw_footer'),enBot);
	}else{
		panelise_plain(document.getElementById('menubar'),enHdr);
		panelise_plain(container.popup_message,enBody3);
		panelise_plain(container.popup_compose,enBody3);
		panelise_plain(document.getElementById('sw_footer'),enBot);
	}

#	document.getElementById("sid").innerHTML = sw_win.sid;
	sw.is_popup=true;
	sw.ajax=true;
	
	sid = sw_win.sid;
	sw.type = pp['type'];
	sw.jmsg = pp.jmsg;
	// Possible remove these two (still being used by popup switch to edit)
	sw.mid = pp.jmsg.cache_mid;
	sw.fld_id = pp.jmsg.fld_id;
	sw.fid = pp.jmsg.fid;
	sw.fld_type = pp.jmsg.fld_type;

	if(sw_win.skin.length>0){
		load_dynamic_css('||www_base||shared/skins/'+sw_win.skin+'/skin.css?||vz||');
	}

#	this all seems a bit juck and maybe should be store in one place??	
	pref_reply=sw_win.pref_reply;
	class_add(document.body,sw_win.pref_colour);
	email=sw_win.email;
	signature=sw_win.signature;
	pref.cur_signature=sw_win.pref.cur_signature;
	pref.compose_sticky=sw_win.pref.compose_sticky;

	sw.jmsg.instance=sw_win.instance;
	unique_instance(document.getElementById('message_container'), sw_win.instance++);

	if(pref.devt_test!='nounload' && !isChrome){
		window.onbeforeunload=function(){if(sw.type=='edit'&&!sw.closing) return "";}
	}
	document.onkeydown=popup_keydown;

	show_xxx_complete_popup();
	init_ui_elements();
	popup_resize();
}

function popup_resize(){
	xx['mnu_h']=panel_correct(sw.menubar).offsetHeight+3;
	xx['screen_h']=ClientHeight();
	
	if (sw.type=='msg'){
		sw.active.style.height=px(xx['screen_h']-(xx['mnu_h']+footer)); 
	}else{
		xx['chdr_h']=sw.active.compose_header.offsetHeight;
		sw.active.field_eframe.style.height=px(xx['screen_h']-(xx['mnu_h']+xx['chdr_h']+footer)-||panel_gap||);
	}
}
function do_delete2(id)
{
	var sel=make_sel(sw.fld_id,id);
	set_status("$$st_stat_del$$","info");
	ajax_delete(sel);
}

function do_move2(id)
{
	var sel=make_sel(sw.fld_id,id);
	set_move_status(sel,t.fname);
	ajax_msg_move(sel,t.fname);
}

function set_move_status(sel,fld)
{
	set_status($('$$st_stat_moving_to$$',fld),"info");
}

# Message list cursor / primary selection handling
#  note these will not always match!! 
#  Ideally I'd only have one but can't decide which would be best for efficiency.
var cursor_mid, cursor_row;	

function cursor_row_valid(cursor_row)
{
	if(!cursor_row) return false;
	if(!cursor_row.sel) return false;
	if(cursor_row.childNodes.length==0) return false;
	return true;
}

# ****************************************************************
# Stuff left over from development I've not cleaned up yet... Not sure how much is essential


var temp_stuff;
var window_list;
var window_uid=0;

var banner_height=||banner_height||;
#var left_column=145;
var right_column=0;
var footer=0;	//22
var pane_ratio=0.5;

var instance=1;
inline_loading='msg';

x_M_param=false;

# Original show message code - only still used for preview display I believe old function M(
function show_preview(mid, extra, type, nofocus, nostatus, disable_markread)
{
	dbg("Message id=="+mid+" display 1");

	if (seen_timer) clearTimeout(seen_timer);

#	var destination=(window.event && window.event.shiftKey)?'message':'message_preview';	
	var destination=(pref.mode=='app'?'message_preview':'message');	
	dbg("destination="+destination)
	if (x_M_param) {destination='message';x_M_param=false;}

	destination='message_preview';
	
	if (destination!='message_preview') {
		fldmsg_display(enMSG);
		sw.msg_pane.menu_ref=sw.menubar.menus["menu_message"];
		window_manager_newtab(sw.msg_pane,'message');
	}
	cursor_mid=mid;
	if(sw_cache && sw_cache[cache_id(sw.fid,mid)]){
		dbg("attempting to load message id="+mid+" from cache");
		var qmsg=sw_cache[cache_id(sw.fid,mid)];
		assign_destination_html(destination,mid,html_from_qmsg(qmsg));
		special_processing(destination,qmsg);	
		if(!disable_markread) mark_read(cursor_mid,true,type);		
	}else{
		if (!extra) extra="";
		set_loading(destination);
		retrieve_msg(sw.fld_id,mid,function(chan){M_cb(chan,destination,type,mid,disable_markread);},extra,nostatus);
#		sndReq('cmd=show&page=~msg.js&msg_id='+mid+"&fld_id="+xescape(sw.fld_id)+extra, function(chan){M_cb(chan,destination,type,mid);});
	}
	if (pref.mode=='web') 
		do_select('none');
	if(type!='initial')
		msglist_select(mid,undefined,nofocus);	
}

function M_cb(chan,destination,type,mid,disable_markread)
{
	doneloading();
	var success=actionReqJsStat(chan);
	var xid=cache_id(sw.fid,mid);

	cache_add(xid,amsg);
	var qmsg=sw_cache[xid];
	assign_destination_html(destination,mid,html_from_qmsg(qmsg));
#	dge(destination).innerHTML=amsg.html;
#	actionReqSethtmlStat(chan.responseText,destination);
#	if (global_auth_error) {
#		global_auth_error=false;
#		return;
#	}
	special_processing(destination,qmsg);	
	if(!disable_markread) mark_read(mid,true,type);
}

function Mx(txt)
{
	fldmsg_display(enMSG);
	sw.msg_pane.innerHTML='<div class="nomessages">'+txt+'</div>';
}


# Old style display layout - still partly used

// (Restore the fldmsg display if somethign else is shown)
// (and make sure that an acceptable msg / fld pane is actually visible)
function fldmsg_display(type)
{
	var a
	var util=sw.util;

	dbg('fldmsg_display');

#	Minimise any other displays
	if(util.active && !class_contains(util.active,'fldmsg'))
		window_manager_minimise(util.active);
#	If no request, just switch back to last
	if (type==undefined){
		type=util.fldmsg_current;
	}
# 	If there is a reques but last is on, just switch back to last	
	if (type&util.fldmsg_current)
		type=util.fldmsg_current;
#	Actually layout the panes		
	layout_fldmsg(type);
	if(sw.msglist_refresh){
		sw.msglist_refresh=false;
		F(sw.fld_id,0,0,false,false);
	}
}
// Arranges the folderlist and message display mode dependant on preferences
function layout_fldmsg(mode)
{
	var oldmode=sw.util.fldmsg_current;

	var maintab=sw.msgs_pane.tab_ref;
	if(!(class_contains(panel_correct(maintab),'selected'))){
		window_manager_minimise(sw.active,true);
		restoreMsgFromTab(maintab);
	}	
#	dbg('layout_fldmsg early');
	if (!sw.msgs_pane) {alert("not init");return;}
	
	if (mode>0) 
		sw.util.fldmsg_current=mode;

	dbg('layout_fldmsg mode='+mode);

#	// All hidden
	if (mode==0){
		class_add(panel_correct(sw.msgs_pane),'hidden');
#		class_add(panel_correct(sw.msg_pane),'hidden');
		sw.active=undefined;
	}
#	// List only display	
	else if(mode==enFLD){					
		menu_set("menu_bar_main");
		class_remove(panel_correct(sw.msgs_pane),'hidden');
		sw.msgs_panelist.style.height="";
#		class_add(panel_correct(sw.msg_pane),'hidden');
		sw.active=sw.msgs_pane;
	}
#	// Message only display	
	else if(mode==enMSG){
		menu_set("menu_message");
		class_add(panel_correct(sw.msgs_pane),'hidden');
#		class_remove(panel_correct(sw.msg_pane),'hidden');
#		sw.msg_pane.style.height="";
#		sw.active=sw.msg_pane;
	}
}

# This is a bit of a hack... but will do for now, lets see if we can improve later
function tweak_unfinished_stuff(){
	var o;
	o=dge("app_menu"); if (o) set_panel_bottom_border_color(o,"#8FC1E6")
	o=dge("beta_panel"); if (o) set_panel_bottom_border_color(o,"#FFFFD1")
}

# ** Still used to update the main central pane **
var util_body_style = enBody3;
function panel_show_old(id,resize)
{
#	window_manager_minimise(sw.active,true);
	var menu=menu_set(id+"_menu");
	var panel=document.getElementById(id+'_panel');
	if (pref.panelise)
		panelise_square(panel,util_body_style);
	panel.menu_ref=menu;
	sw.active=panel;
	sw.active.resize=resize;
	do_resize_real();
}
function panel_show_old2(id)
{
#	var menu=menu_set(id+"_menu");
	var message=document.getElementById('message_panel');
	var compose=document.getElementById('compose_panel');

	message.parentNode.sw_message=message;
	compose.parentNode.sw_compose=compose;

	if (pref.panelise){
		panelise_square(message,util_body_style);
		panelise_square(compose,util_body_style);
	}
	message.menu_ref=sw.menubar.menus["menu_message"];
	compose.menu_ref=sw.menubar.menus["menu_compose"];
	menu_set("menu_message");
#	setTimeout('init_editor("eframe");',100);	
	sw.active=message;
	do_resize_real();
}


# *** Core layout switching routine (NEEDS TIDYING) ***

# Window layout variables
var layout_type;
var preview=false;

var list_h=0;
var count=1;
var last_cc_h=-1;

function do_layout()
{
	dbg('>> do_layout');

#	if (type.length<1) type="a2v";
#	if (type==layout_type) return;

	var mnu=document.getElementById("layout_menu");
	var ml=document.getElementById("messages_list");
	var ml_bx=document.getElementById("msglist_box");

	var msg_p=document.getElementById("message_preview");
	var sz2=document.getElementById('sizer2')
#	var div3=document.getElementById("message_preview");
	class_add(mnu,'hidden');

# 	convert new preferences into old set call (function below should be rewritten, to not need this)
	var type='';
	switch(pref.mode){
		case'app':type+='a';break;
		case'web':type+='w';break;
	}
	switch(pref.preview){
		case'horiz':type+='2h';break;
		case'vert':type+='2v';break;
		case'none':type+='1';break;
	}
		
	if (type=='w1') { 
		layout_fldmsg(enFLD); 
		class_add(msg_p,'hidden'); 
		class_remove(ml_bx,'a2h_list'); 
		ml_bx.style.height="";
		ml_bx.style.width="";
	}
	if (type=='a1') { 
		layout_fldmsg(enFLD); 
		class_add(msg_p,'hidden'); 
		class_remove(ml_bx,'a2h_list'); 
		ml_bx.style.width="";
#		preview=false;
	} 
	if (type=='a2h') { 
		layout_fldmsg(enFLD); 
		class_remove(msg_p,'hidden'); 
		class_add(sz2,'hidden'); 
		class_add(ml_bx,'a2h_list'); class_remove(msg_p,'a2v_msg');
	}
	if (type=='a2v') { 
		layout_fldmsg(enFLD); 
		class_remove(msg_p,'hidden'); class_remove(sz2,'hidden'); 
		class_remove(ml_bx,'a2h_list'); class_add(msg_p,'a2v_msg');
	}
	
#	if (layout_type){
#		pref_layout=type;
#		ajax_pref_save('pref_layout='+pref_layout);
#	}
	layout_type=type;

	if (type.indexOf('2')!=-1){
#		class_remove(sz2,'hidden');
		var x_list=document.getElementById('msglist_box')
		var x_ban=document.getElementById('top_banner')
		var x_mnu=panel_correct(document.getElementById('menubar'))
#		x.style.top=(q.offsetTop+x_list.offsetHeight)+'px';
		if (type=='a2v') {
#			sz2.style.top=(x_ban.offsetHeight+x_mnu.offsetHeight+x_list.offsetHeight+2)+'px';			
			dbg("*** ban="+x_ban.offsetHeight+' mnu='+x_mnu.offsetHeight+' list='+x_list.offsetHeight)
			preview='v';
		}else{
			preview='h';
		}
	}else{
		class_add(sz2,'hidden');
		preview=false;
	}
	
	var switcher=document.getElementById('switcher');
	if (pref.windows=='tabbed'){
		class_remove(switcher,'hidden');
	}else{
		class_add(switcher,'hidden');
	}	

	// temporary for debugging
	if (pref.windows=='inline'){		
		class_remove(document.getElementById('msg_menu_back'),'hidden');
		if(pref.devt_mode){
			class_remove(switcher,'hidden');
			switcher.style.background='red';
		}
	}

	do_resize_real();
}

function app_menu_init()
{
	if (pref.no_blogs)
		class_add(document.getElementById("app_blogs"),'hidden');
	if (pref.no_surgeplus){
		class_add(document.getElementById("app_calendar"),'hidden');
		class_add(document.getElementById("app_filestore"),'hidden');
		class_add(document.getElementById("app_photos"),'hidden');
	}
	app_menu('mail',dge('app_menu_mail'));
}

var first_message='';
function set_first_message(id,keep_selection,disable_markread,no_select)
{
	if(istrue(keep_selection)){
		first_message=id;
	}else{
		dge('message_preview').innerHTML='<div class="nomessages">$$st_info_nomsg_sel$$</div>';	
		if(no_select) return;
		if(id.length>0 && pref['message_done_action']!='none'){
			msglist_select(id);
			show_preview(id,'','initial',undefined,undefined,disable_markread);
		}
	}
}
function set_folders(txt)
{
	var el=document.getElementById('folders');
	el.innerHTML=txt;
	el.onclick=folder_click;
	clear_folder_menu('folder_menu');
}

function check_new_mail()
{
	queued_req_add( enBG, 'check_mail', function(){
		sndReq('cmd=check_mail,show&page=~result.js&idle=true', function(chan){
			if (chan.status!=200){
				success_string=err_comms();
				set_status('$$st_newchk_fail$$ '+success_string,'warning');
				update_ssb_status(-1);
				return;
			}
			var success=actionReqJsStat(chan);
			if(!success){
				update_ssb_status(-1);
				return;
			}
			if (sw.folder_check && sw.folder_check<time()-10*60)
				refresh_flds();
		},ch[enBG]);
	});
}

function new_mail(n,ids,updating)
{
	var txt=(updating?'':$('$$st_newchk_refresh2$$',' <a href="#" onclick="F(\'INBOX\',\'1\',undefined,true)">','</a>'));
	set_status( $('$$st_newchk_refresh$$',n,plural(n),txt),'success');
	if (pref.sounds=='new' || pref.sounds=='all') 
		play_sound('new');
	
#	var sel=make_sel(fld,mid);
	var sel=[ids];
 	sel.fld_id='INBOX';
 	sel.fld_type=1;
	ajax_cache_messages(sel,true);
}

var checknew_timer;
var checknew_next;
var checknew_last=time();
function check_new_timed()
{
	if (pref.nocheck) return;
	if(pref.devt_test=='nobg') return;

	var t=time();
	dbg('last_check='+(t-checknew_last) +' untouched='+(t-sw.last_action));
	var untouched=t-sw.last_action;
	if(t-checknew_last>(15*60)) {
#		Computer has probably been asleep or something, pretend we touched it to 
#   	get status updates coming again asap.
		touch(9);
		wait=4;
	}else if(untouched<(5*60)){
		wait=20;
	}else if (untouched<30*60){
		wait=60;
	}else{
		wait=5*60;
	}

	checknew_next=t+wait;
	dbg('Last user action '+untouched+'s ago, new mail check in '+wait+'s');
	checknew_timer = setTimeout(function(){
		dbg('checking new mail')
		check_new_mail();
		check_new_timed();
		checknew_last=time();
	},wait*1000);
}
function check_idle()
{
	return time()-sw.last_action>60?true:false;
}
function upgraded_and_safe()
{	
	dbg('fluid check: upgrade_pending='+sw.upgrade_pending+' check_idle='+check_idle()+' ('+sw.last_action+')'+' tabs='+dge('switcher').childNodes.length);
	return sw.upgrade_pending&&check_idle() && dge('switcher').childNodes.length==1?true:false;
}
# ***



function vtab_init(prefix,item)
{
	var divs=document.getElementById("options_tabs").getElementsByTagName('div');
	for(var i=0;i<divs.length;i++){
		id=divs[i].id;
		if(id.substring(0,2)=="ot") class_remove(divs[i],"selected");
		if(id.substring(0,2)=="ob")	class_add(divs[i],"hidden");
	}
	class_add(document.getElementById("ot"+item),"selected");
	class_remove(document.getElementById("ob"+item),"hidden");
}



function upload_init(node) {
	var settings = {
		flash_url : "||www_base||shared/modules/swfupload.swf",
		upload_url: '/surgeweb?cmd=attach_upload,show&sid='+sid+'&if=ajax&page=~result.js',	// Relative to the SWF file

		button_width: sw.active.button_place_holder.nextSibling.offsetWidth,
		button_height: sw.active.button_place_holder.nextSibling.offsetHeight,
		button_placeholder_id: 'spanButtonPlaceHolder'+sw.active.instance,
#		button_text: '<span class="theFont">Hello</span>',
#		button_text_style: ".theFont { font-size: 16; }",
#		button_text_left_padding: 12,
#		button_text_top_padding: 3,

		post_params: {'attach_mid' : sw.active.jmsg.attach_mid, 
					  "PHPSESSID" : "<?php echo session_id(); ?>", 	// Various bits of crap to be removed
					  "comment":"Some other thing like comment"},
		file_size_limit : "100 MB",
		file_types : "*.*",
		file_types_description : "All Files",
		file_upload_limit : 100,
		file_queue_limit : 0,
		custom_settings : {
			progressTarget : node.attach_progress.id,
			cancelButtonId : "btnCancel"
		},
		debug: false,


		// The event handler functions are defined in handlers.js
		file_queued_handler : fileQueued,
		file_queue_error_handler : fileQueueError,
		file_dialog_complete_handler : fileDialogComplete,
		upload_start_handler : uploadStart,
		upload_progress_handler : uploadProgress,
		upload_error_handler : uploadError,
		upload_success_handler : uploadSuccess,
		upload_complete_handler : uploadComplete,
		queue_complete_handler : queueComplete	// Queue plugin event
	};
	
#	// Safari & FF do not these cookies through Flash, so do ourselves
#	//  but the following does not work under IE!! go figure.... at least it does enough to do what I want  :-)
	var s=get_cookie("SW-AUTHTOKEN");
	if (s) settings.post_params['SW-AUTHTOKEN']=s;

	node.swfu = new SWFUpload(settings);
	node.swfu.sw_panel=node;
}


# **** 
function pct_clean(s) {
	return s.replace(/%%/g,'%')
}
function quota_info() {
	return pct_clean($('$$st_quota_pct$$',sw.quota.pct,sw.quota.limit));
}

function do_exta_status()
{
	info = '<div style="margin-left:60px;">';
	if(sw.quota)
		info += '<p>Current Quota: '+quota_info();
	info +='<p>Channel status:'+qchan_debug();	
	info +='<p>calls to mtime()='+time_calls+' BAD='+time_bad;	
	info += '</div>'
	x_alert(info);
}

function attachment_status(node,o)
{
	node.innerHTML=o.length+' file'+(o.length==1?'':'s')+' attached';
}

function attachment_add(node,att)
{
	if(sw.is_popup) return sw_win.attachment_add(node,att);

	var jmsg=node.jmsg;

	if (!jmsg.attach_ids){
		jmsg.attach_ids=[];
		jmsg.attach_info=[];		
	}
	jmsg.attach_ids.push(att[1]);
	jmsg.attach_info.push(cloneObject(att));
}
function attachment_remove(node,id)
{
	var jmsg=node.jmsg;
	var i=my_indexOf(jmsg.attach_ids,id);
	if(i!=-1){
		jmsg.attach_ids.splice(i,1);
		jmsg.attach_info.splice(i,1);
	}
	attachment_status(node.attach_status,jmsg.attach_ids);
}
function do_attach()
{
	alert('$$st_err_noflash2$$')
}
function do_attach_init()
{
	if(sw.active.jmsg.action=='redirect'){
		alert('Redirected messages cannot be modified');
		return;
	}

	attachments_init();
	
#	attach_retries=0;
#	do_attach_step2();
}
function attachments_init()
{
	dbg('attachments button pressed')

	var o=sw.active.attachments
	if (class_contains(o,'hidden')){
		class_remove(o,'hidden');
		
		if(sw.is_popup){
			popup_resize();
		}else{	
			do_resize_real();
		}
	}
	if(!sw.active.swfu){
		setTimeout(function(){upload_init(sw.active);},10);
#		upload_init(sw.active);
	}else{
		alert('$$st_info_attach_new$$');
	}
}

var attach_retries;
function do_attach_step2()
{
	return;
#	if(sw.active.swfu.PercentLoaded()<100){
#		if(attach_retries<100){
#			attach_retries++;
#			setTimeout(do_attach_step2,50);
#			return;
#		}
#	}
	
	try {
		sw.active.swfu.selectFiles();
	} catch (ex) {
		alert(ex);
		if(attach_retries<100){
			attach_retries++;
			setTimeout(do_attach_step2,50);
			return;
		}
		x_alert('$$st_err_noflash$$');
		dbg('attachments interface could not be initialised')
	}	
}
function do_attach_removeall()
{
	var node = sw.active;
	node.swfu.cancelQueue();
	node.attach_progress.innerHTML="";
	node.jmsg.attach_ids=[];
	dbg('attachment remove all pressed')

	attachment_status(node.attach_status,node.jmsg.attach_ids);
}



function get_cookie(name) {
#alert(document.cookie)

    var dc = document.cookie;
    var prefix = name + "=";
    var begin = dc.indexOf("; " + prefix);
    if (begin == -1) {
        begin = dc.indexOf(prefix);
        if (begin != 0) return null;
    } else {
        begin += 2;
    }
    var end = document.cookie.indexOf(";", begin);
    if (end == -1) {
        end = dc.length;
    }
    return unescape(dc.substring(begin + prefix.length, end));
}


function xmenu_init(){
	xmenu_register_jshover(dge('top_menu_options'));
	xmenu_register_jshover(dge('pg_menu_select'));
	xmenu_register_jshover(dge('pg_menu_sort'));
	xmenu_register_jshover(dge('pg_menu_display'));
}

function update_folder(fid,search)
{
	if(fid) sw.fid=fid;
	sw.xfolder=search?true:false;
}
function update_unread(fld_id,txt)
{
	var el=dge('unread_'+fld_id);
	if (!el) return;
	el.innerHTML=txt;
}
function update_unread_many(o)
{
	var el,len=o.length;
	for(var i=0;i<len;i++){
		if(o[i].fld_id=='INBOX') update_ssb_status(o[i].unread);
		el=dge('unread_'+o[i].fld_id);
		if (!el) return;
		el.innerHTML=o[i].unread==0?'':'('+o[i].unread+')';
	}	
#	set_status('Unread messages updated in '+len+' folder'+plural(len),'success');
}
function update_ssb_status(count)
{
	if (window.fluid){
		var txt='';
		if(count>0) txt=count;
		if(count<0) txt='???';
		window.fluid.dockBadge=txt;
		dbg('fluid status update=['+txt+'] count='+count);
		
		if(window.surgeweb_fluid_version && window.surgeweb_fluid_version!=1 && !window.fluid_warned){
			alert('A newer Fluid SurgeWeb user script is available');
			window.fluid_warned=true;
		}
	}
}


function navigator_set(first,count,total,txt)
{
	var o=dge('msg_navigator'); 
	if (o) o.innerHTML=txt;
	sw.nav_first=first;
	sw.nav_count=count;
	sw.nav_total=total;
#	dbg("*** Nav_set "+sw.nav_first+':'+sw.nav_count+':'+sw.nav_total)
}

function navigator_update()
{
	var o;
	if(sw.nav_total>0){
		o=dge('nav_first'); if (o) o.innerHTML=sw.nav_first;
		o=dge('nav_total'); if (o) o.innerHTML=sw.nav_total;
		o=dge('nav_last'); if (o) o.innerHTML=sw.nav_first+sw.nav_count-1;
	}else{
		o=dge('msg_navigator'); if (o) o.innerHTML='';
		no_msg_sel();
	}
	if(sw.nav_count==0&&sw.nav_total>0 || sw.nav_count<50&&sw.nav_total!=sw.nav_count){
		var start = (sw.nav_first+100<sw.nav_total) ? sw.nav_first-1 : sw.nav_total - 100;
		F(sw.fld_id,sw.fld_type,start,false,true);
	}

#	dbg("*** Nav_update "+sw.nav_first+':'+sw.nav_count+':'+sw.nav_total)
#	if(dge('nav_first')) dbg("*** Nav_update "+dge('nav_first').innerHTML+' - '+dge('nav_last').innerHTML+' of '+dge('nav_total').innerHTML  )
}

function touch(id)
{
#	dbg("** touch "+id);
	sw.last_action=time();
	var wait=checknew_next-sw.last_action
	if(wait>20){
		dbg("touch "+id+" - changing checknew_timer from "+wait+"s to 20s");
		clearTimeout(checknew_timer);
		check_new_timed();
	}
	if (id>=5 && id<=8) 
		refresh_ad()
}

# Mostly seems to stop the one pixel shift which clicking links in IE sometimes has
#   todo look for better fix	
function stop_shift()
{
	if(isIE) {
		e=window.event;
		if (!e) return;
		stopEvent(e);
	}
}

function contact_click_send(email,name)
{
	if(sw.is_popup) return sw_win.contact_click_send(email,name);
	do_new_email(name,email);
}
function contact_click_add(email,name)
{	
	if(sw.is_popup) return sw_win.contact_click_add(email,name);
	var extra='&old_nickname=&contact_nickname='+xescape(encode_quotes(email))+'&contact_email='+xescape(encode_quotes(email))+'&contact_name='+xescape(encode_quotes(name));
#	queued_req_add( enBG, 'contact_add', function(){
		sndReq('cmd=contact_add,show&page=~result.js'+extra, function(chan){
#			if(chan.responseText.indexOf('no such template')!=-1){
#				set_status("Contact save failed (probably already in addressbook)",'warning');
#			}else{
				var success=actionReqJsStat(chan);
				if(success){
					set_status($('$$st_ct_save_success$$',email),"success")
				}else{
					set_status('$$st_ct_save_fail$$ ('+success_string+')','warning');
				}
//			}
		});
#		},ch[enBG]);
#	});	
}


function shiftkey(){
	var o=window.event;
	if (!o) return false;
	return o.shiftKey;
}

function no_msgs_fld()
{
	setMessages('<span><div class="nomessages">$$st_info_nomsg_fld$$</div></span>');
}
function no_msg_sel()
{
	dge('message_preview').innerHTML='<div class="nomessages">$$st_info_nomsg_sel$$</div>';
}

# Javascript based UI extension functionality

function extend_init(type)
{
	if(type==1 && window.js_extend_init_early)
		js_extend_init_early()
	if(type==2 && window.js_extend_init_late)
		js_extend_init_late()
}

function init_ui_elements()
{
	footer=dge('sw_footer').offsetHeight;
}


# ----------------------
# Implementation of client side panel "look and feel"
# valid: 'orig', 'plain', 'none'; 
var panel_mode='||panel_mode||';
var panel_gap=||panel_gap||;
function panelise()
{
	if (!pref.panelise) return;

#	Always round the corners of the status
	panelise_round(document.getElementById('status'),enBoth);

// Nothing at all panelised
	if(panel_mode=='none'){	
		panelise_none(document.getElementById('menubar'),enHdr);
		panelise_none(document.getElementById('lpanel_hdr'),enHdr);
		panelise_none(document.getElementById('messages'),util_body_style);
		panelise_none(document.getElementById('lpanel_body'),enBody);
		panelise_none(document.getElementById('app_menu'),enHdr);
		panelise_none(document.getElementById('contacts'),enHdr);
		var o=document.getElementById('custom_lpanel'); if (o) panelise_none(o,enPlain);
		panelise_none(document.getElementById('sw_footer'),enBot);

# Left column not panelised
	}else if (panel_mode=='plain') { 
		panelise_plain(document.getElementById('lpanel_hdr'),enHdr2);
		panelise_plain(document.getElementById('lpanel_body'),enBody2);
		panelise_plain(document.getElementById('app_menu'),enBody2);
		panelise_plain(document.getElementById('contacts'),enHdr2);
		var o=document.getElementById('custom_lpanel'); if (o) panelise_none(o,enPlain);
#		Center column and status
		panelise_roundtop(document.getElementById('menubar'),enHdr);
		panelise_plain(document.getElementById('messages'),util_body_style);
		panelise_plain(document.getElementById('sw_footer'),enBot);
	
#	Original design
	}else{
#		Left column panels
		panelise_roundtop(document.getElementById('lpanel_hdr'),enHdr);
		panelise_square(document.getElementById('lpanel_body'),enBody);
		panelise_round(document.getElementById('app_menu'),enHdr);
		panelise_round(document.getElementById('contacts'),enHdr);
		var o=document.getElementById('custom_lpanel'); if (o) panelise_square(o,enPlain);
#		Center column and status
		panelise_roundtop(document.getElementById('menubar'),enHdr);
		panelise_square(document.getElementById('messages'),util_body_style);
		panelise_square(document.getElementById('sw_footer'),enBot);
	}
}

# Add new custom panels on the left
var panel_ids=1;
function new_panel_basic(content_body, top)
{
	var a=new_anchor_before("foobar", top=='top'?"lpanel_hdr":"contacts");
	a.className="left_pane";
	a.innerHTML='<div style="background:||lpanel_color||;padding:3px;">'+content_body+'</div>';	
	if(panel_mode=='orig'){
		panelise_round(a,enBoth);
	}else if(panel_mode=='plain'){
		panelise_plain(a,enBody2);
	}else{
		panelise_none(a,enBoth);
	}
}
function new_panel_fancy(content_header, content_body, top, plain)
{		
	var a=new_anchor_before("foobar", top=='top'?"lpanel_hdr":"contacts");
	a.className="left_pane";
	a.innerHTML='<div class="left_panel_header"> <span style="padding-left:5px">'+content_header+'</span></div><div style="background:white;'+(plain==true?'':'padding:3px;')+'">'+content_body+'</div>';
	var xhdr=a.firstChild;
	var xbody=a.firstChild.nextSibling;
	if(panel_mode=='orig'){
		panelise_roundtop(xhdr,enHdr);
		panelise_square(xbody,enBody);
	}else if(panel_mode=='plain'){
		panelise_plain(xhdr,enHdr2);
		panelise_plain(xbody,enBody2);
	}else{
		panelise_none(xhdr,enHdr);
		panelise_none(xbody,enBody);
	}
}

// Possibly combine this function with some of our own background downloads
function prefetch_init(msgs)
{
	flash_embedSWF2("||www_base||shared/modules/flash_audio.swf?||vz||");

	download_contacts();
	download_dialogs();
	cache_inbox(msgs);
	prefetch_images();
	refresh_flds();
	
	sw.done_prefetch=true;
#	var head = document.getElementsByTagName('head')[0];
#	var node = document.createElement('embed');
#	head.appendChild(node);
#	node.setAttribute('src', url);
}

var prefetch_img_urls=['ajax/img/dlg_alert.png','ajax/img/gradient.gif','ajax/img/dlg_confirm.png','shared/img/shadow_cnr.png','shared/img/shadow_vert.png','shared/img/shadow_horiz.png'], 
	prefetch_img_images=[];
function prefetch_images()
{
	for(var i=0;i<prefetch_img_urls.length;i++){
		prefetch_img_images.push(new Image());
		prefetch_img_images[i].src=wwwbase+prefetch_img_urls[i]+'?||vz||';
	}	
}


function cache_inbox(msgs)
{
	if(pref.devt_test=='nobg') return;
	if (pref['nocache'] || msgs.length==0) return;

	if (done_cache) return;

	done_cache=true;
	ajax_cache_messages(msgs);	
}



function download_contacts()
{
	if(pref.devt_test=='nobg') return;
	queued_req_add( enBG, 'download_contacts', function(){
		sndReq('cmd=show&page=~contacts.js', function(chan){
			var success
			success=actionReqJsStat(chan);
#				contact_error();
		},ch[enBG]);
	});
}

function download_dialogs()
{
	queued_req_add( enBG, 'download_dialogs', function(){
#		sndReq('cmd=show&page=~dialogs.htm&dialog=contact_picklist', function(chan){			
		sndReqCached('cmd=show&page=~dialogs.htm&dialog=contact_picklist&if=ajax&static=||web_ref_path||&||vz||', function(chan){			
			new_anchor('div',chan.responseText);			
			cp_init();
		},ch[enBG]);
	});
}

function refresh_flds(all)
{
	if(pref.devt_test=='nobg') return;

	queued_req_add( enBG, 'refresh_flds', function(all){
		sndReq('cmd=folders_refresh,show&page=~result.js&idle=true'+(all?'&refresh_allflds=true':''), function(chan){
			var success=actionReqJsStat(chan);
			sw.folder_check=time();
			if(all) set_status('$$st_stat_rfrall_complete$$','success')
		},ch[enBG]);
	},all);
}



# Setup live andmin interface refresh possibilities
#var live_url;
#var live_master;
#function live_refresh(win,url,just_reload)
#{
#	if(just_reload){
#		setTimeout(do_reload,150);
#	}else{
#		setTimeout(function(){document.location.href=url},150);
#	}
#	return;
#	if (win) live_master=win;
#	if (url) live_url=url;
#	if(!live_master || !live_master.live_update || !live_master.foobar) setTimeout(live_refresh,500);
#	live_master.live_refresh_cb(window,live_url);
#}




function info_panel_init()
{
	if(info_panel.length>0)
		new_panel_basic(info_panel,'top');
}

function prcc_new_attach(node,attach,attach_mpr)
{
	// If we are adding it after popin / out then RESET the jmsg count here
#	node.jmsg.attach_ids=[];	
	for(var i=0;i<attach.length;i++){
		attach_myfile(node,attach[i]);
	}
	node.jmsg.attach_ids_mpr=attach_mpr;
}

function attach_myfile(node,att)
{
	var o=node.jmsg.attach_mid=att[0];

	var file={};
	file.id='myattach-'+att[0]+'-'+att[1];
	file.name=att[2];
	var progress = new FileProgress(file, node.swfu.customSettings.progressTarget,(node.jmsg.action=='redirect'));


	progress.setComplete();
	attachment_add(node,att);
	attachment_status(node.attach_status,node.jmsg.attach_ids);

	progress.fileProgressWrapper.sw_id=att[1];
	progress.setStatus(att[3]);
	progress.toggleCancel(true, node.swfu);
}

var g_new_attach=[],g_new_attach_mpr;
function upload_results(att,att_mpr)
{
#	dbg('results: '+att.length+' attachments');
	g_new_attach=att;
	g_new_attach_mpr=att_mpr;
}
#function upload_results2(atts)
#{
#	for(i=0;i<atts.length;i++){
#		attach_myfile(atts[i]);
#	}
#}


function switch_selfld(fld_id,opt)
{
	var el;
	var fld_id_old=sw.fld_id;

	if(!opt) opt={};

	sw.fld_id=fld_id;
	var fld_id_txt=fld_id;
	if (fld_id_txt=='INBOX') fld_id_txt='Inbox';
	if (opt.multiple) fld_id_txt='<i>Multiple folders</i>';
	sw.multiple=opt.multiple;

	document.getElementById("foldername1").innerHTML=fld_id_txt;
	document.getElementById("foldername2").innerHTML=fld_id_txt;
	el=document.getElementById("foldername_tab");
	if (el) el.innerHTML=fld_id_txt;

	el=dge('unread_'+fld_id_old);
	if (el) class_remove(ancestor_by_class(el,'full_cursor'),"selected");
	if(!opt.multiple){
		el=dge('unread_'+fld_id);
		if (el) class_add(ancestor_by_class(el,'full_cursor'),"selected");
	}
}

function column3_init()
{
	if(column3.length>0 && column3!='none'){
		right_column=||right_column_width||+panel_gap+2;
		var x=document.getElementById('right_column');
		class_remove(x,'hidden');
	}
# the below does not work ??	
#	dge('right_column').innerHTML=''+
#	  	'<span style="font-size:10px">advertisement</span>'+
#	  	<div style="border:1px solid ||border_color||;width:120px;height:600px;text-align:left;"><div style="padding:3px">Div for <br>arbitrary use: <br> - Information <br> - hints <br> - advertising??</div></div>
#	  	'<div style="border:1px solid ||border_color||;width:120px;height:600px;text-align:left;">||ad2_html||</div>';
#	alert('||ad2_html||');
}


function user_cgi_dlg(type)
{
	var cmd='cmd=doauto_login&product=usercgi&sid='+sid; //&type=blogs
	var txt='Serverside email filtering';
	var extra='&combine_spam_friends=true'
			+ '&rating_probable='+ pref.rating_probable+'&rating_certain='+pref.rating_certain
			+ '&spam_hide_advanced='+pref.spam_hide_advanced+'&use_late='+usercgi_status['use_late'];

	switch(type){
		case 'responder': 	
		case 'forwarding':
		case 'filtering':
		case 'whitelist':	
		case 'spam': 		
		case 'friends':
		case 'password':
							cmd+='&type='+type+extra; break;
		case 'log': 
							cmd+='&type='+type; break;

		case 'raw': 
			txt='Raw user.cgi interface';		
			cmd+='lcmd='; 
			break;
	}
	
	if(type!='raw')
		cmd+='&surgeweb=true';
		
	cmd+='&utoken='+utoken;
	x_custom_dlg2(txt+' (user.cgi in a dialog) ',
				 '<iframe src="'+cgibase+cmd+'" style="width:100%;height:'+px(ClientHeight()*0.9-100)+'"></iframe>',
		function(btn){
			ie_fixfocus();
			usercgi_summary();
	}, U, {'tall':true,'width':0.9});
}

function user_cgi_popup(type)
{
#	open_popup2(backend+'cgi/user.cgi?utoken='+utoken+type);
	open_popup2(cgibase+'cmd=doauto_login&product=usercgi&type=&sid='+sid);
}

function subject_init(){
	var ctl=sw.active.field_subject; 
	add_event(ctl,'blur',function(){
		set_tab_text(ctl.value.length>0?ctl.value:'$$st_new_message$$');
	});
}


// see: get_addresses_sw for dialog outer prefetch
//		show_contacts for dialog initialisation

# *** msglist D&D :-)
var UA = navigator.userAgent.toLowerCase();
isFFok = UA.indexOf('firefox/3') != -1;
isIEok = UA.indexOf('msie 7') != -1 || UA.indexOf('msie 8') != -1;
Browser = {isIE  : isIEok, isIE6 : false, isIE7 : true, isIE8 : false, isFF: isFFok};
Loc = {isBidi : false, LEFT : "left",RIGHT : "right",LRM : "\u200e",RLM : "\u200f"};

var dnd;
function msgdnd_init(){
    if(sw.dnd_disabled) return;
    if(dnd) { dnd.dispose(); dnd=null; }
    DND.RegisterDropTarget(dge("folders").parentNode, dnd1dst_OnDragOver, dnd1dst_OnDragOut, dnd1dst_OnDragDrop);
	dnd=new DND(dge('messages_list'), dnd1src_OnDragStart, dnd1src_OnDragEnd, dnd1src_OnNoTarget);	
}

function dnd1src_OnDragStart(jc,o){
	dbg("CUSTOM D&D dragstart 1");
    o.data = {validStart: false};
	var row=ancestor_by_class(o.overElement,'msgs_line');
	if (!row) return;
	var cell=ancestor_by_tag(o.overElement,'td');
	if(cell==row.childNodes[0] || cell==row.childNodes[1]) return;

	if (isMac&&event.ctrlKey) {return;}

	if (!class_contains(row,'selected')) {
		if(!ctl_cmd_key(event))
			select_none_fast();
		if (event.shiftKey && shift_sel_start){
			complete_selection(row,true);
		}else{
			row_select(row,true);		
		}
	}

	var sel=find_sel(true);
	if (!sel) return false;

    o.data = {validStart: true, sel: sel, toDiv: null, copy: event.ctrlKey };
	for_each_msg(o.data.sel,'pending');
    dnd1_iconCreate(o.data,sel.sel_all?sw.nav_total:sel.length);
    dnd1_iconUpdate(o.data,false);
}
function dnd1src_OnDragEnd(jc,o){
    var d = o.data;
    if (!d.validStart) return;
	dbg('CUSTOM D&D dragend (***) end='+log_element(o.fromElement)+' to='+log_element(o.toElement));
	
	if(!o.success || d.copy)
		for_each_msg(o.data.sel,'nopending');
	dnd_iconRemove(d.drag_div);
	for (var i=0;i<collapse_restore.length;i++){
		fld_expand(undefined,undefined,collapse_restore[i]);
	}
	collapse_restore=[];
} 
function dnd1src_OnNoTarget(jc,o){
    var d = o.data;
    if (!d.validStart) return;
    dnd1_iconUpdate(o.data,false,true);
}
var collapse_timer, collapse_restore=[];
function dnd1dst_OnDragOver(jc,o){
    var d = o.data;
#    var el = ancestor_by_att(o.overElement, "fld_id");
    var el = ancestor_by_class(o.overElement, "full_cursor");
#    dbg('do valid='+d.validStart+el_info(el)+'[['+el_info(o.overElement)+']]');
    if (!el || !d.validStart) {
        if (d.toDiv) class_remove(d.toDiv,'dnd_sel');
        d.toDiv = null;
	    dnd1_iconUpdate(d,false);
        return;
    }
    dnd1_iconUpdate(d,true);
    if (el == d.toDiv) return;
    if (d.toDiv) class_remove(d.toDiv,'dnd_sel');
    if (el.id == d.currFid) {
        d.toDiv = null;
        return;
    }
    d.toDiv = el;
	class_add(d.toDiv,'dnd_sel');
	
	if(collapse_timer){
		clearTimeout(collapse_timer);		
		collapse_timer=null;
	}
	if(class_contains(el.parentNode,'closed')){
		var node=el.parentNode;
		collapse_timer=setTimeout(function(){
			fld_expand(undefined,undefined,node);
			DND._UpdateDropTargetRegions();
			collapse_restore.push(node);
		},1000)
	}
}
function dnd1dst_OnDragOut(jc,o){
    var d = o.data, fld = d.toDiv;
    if (!d.validStart) return;
   	dnd1_iconUpdate(d,false);
    if (d.toDiv) class_remove(d.toDiv,'dnd_sel');
    d.toDiv = null
    clearTimeout(collapse_timer);
    collapse_timer=null;
}
function dnd1dst_OnDragDrop(jc,o){
    var d = o.data;
    if (!d.toDiv || !d.validStart) return;
    if (d.toDiv) class_remove(d.toDiv,'dnd_sel');

	dbg('Actioning message DND '+(d.copy?'COPY':'MOVE')+' to folder ['+fld_id+']');
	var fld_id=d.toDiv.parentNode.getAttribute('fld_id')
    if(d.copy){
		set_status('$$st_stat_copying$$',"info");
		ajax_msg_copy(d.sel,fld_id,false,event.shiftKey);
	}else{
		set_move_status(d.sel,fld_id);
		ajax_msg_move(d.sel,fld_id,false,event.shiftKey);
		do_select('none');
		message_done_action(d.sel);
	}        
    o.success = true
}


var dnd2;
function dnd2_init(){
    if(sw.dnd_disabled) return;
    if(dnd2) { dnd2.dispose(); dnd=null; } 
    DND.RegisterDropTarget(dge("cm_groups"), dnd2dst_OnDragOver, dnd2dst_OnDragOut, dnd2dst_OnDragDrop);
	dnd2=new DND(dge('cm_contacts'), dnd2src_OnDragStart, dnd2src_OnDragEnd, dnd2src_OnNoTarget);	
}

var hack_nosize=false;
var hack_el;
function dnd2src_OnDragStart(jc,o){
	dbg("CUSTOM D&D dragstart 2");
    o.data = {validStart: false};
	var el=ancestor_by_class(o.overElement,'cm_contact');
	if (!el) return;
	var c=abooks[el.getAttribute('cm_abk')].data[el.getAttribute('cm_cid')];
	if (!class_contains(el,'selected')) cm_select_contact(el,event);
    o.data = {validStart: true, sel: el, toDiv: null, fromDiv: el, c: c };
    dnd2_iconCreate(o.data,1);
    var v=dnd2_validity(U,o.data);
    dnd2_iconUpdate(o.data,v.icon_ok,undefined,v.icon_text);
#	if(!contact_editable(c)){
#    	o.data.nodrag=true;
#    }
    o.data.do_shared=c.shared;
    hack_nosize=true;
}
function dnd2src_OnDragEnd(jc,o){
    var d = o.data;
    if (!d.validStart) return;
	dbg('CUSTOM D&D dragend (***) end='+log_element(o.fromElement)+' to='+log_element(o.toElement));
	dnd_iconRemove(d.drag_div);
    hack_nosize=false;
} 
function dnd2src_OnNoTarget(jc,o){
    var d = o.data;
    if (!d.validStart) return;
    dnd2_iconUpdate(o.data,false,true);
}

function dnd2_ToIconText(c,g,el,id)
{
	if(!contact_editable(c)){
    	return '$$st_ct_dndbad$$';					//This type of contact cannot be organised in your personal addressbook<br>(includes shared, webmail and groups)
    }
	if(id=='all') return '$$st_ct_dnd_alreadyall$$';// Already part of All Contacts
	if(!g) return '$$st_ct_dnd_adding$$';			// Adding to group
	if(g.webmail) return '$$st_ct_dnd_noweb$$'		// Cannot modify webmail addresbook
	
	if(g.shared && !c.shared){
		if(group_editable(g))
			return 'Copy to shared addressbook';
		else
			return '$$st_ct_dnd_no_p2s$$';			// Cannot add personal contact to shared groups
	}else if(c.shared && !g.shared){
		return '$$st_ct_dnd_no_s2p$$';				// Cannot add shared contact to personal groups
	}else if (el && class_contains(el,'selected')){
		return $('$$st_ct_dnd_already$$',g.name);	// Already part of %s group
	}else{			
		return $('$$st_ct_dnd_adding2$$',g.name);	// Adding to group %s
	}
}
var ic_grey=0,ic_green=1,ic_red=2;
function dnd2_validity(el,d)
{
	var r={};
	r.valid=false;
	r.icon_text='Organise contact'; // $$st_ct_dnd_adding$$
	r.icon=ic_grey;

#	dbg('*** d.validStart='+d.validStart+' d.nodrag='+d.nodrag);


	if(d.c.webmail){
		r.icon_text='Cannot drag & drop webmail contacts'; // $$st_ct_dnd_adding$$			
		return r;
	}
	if(!el || !d.validStart /*|| d.nodrag*/){
		return r;
	}
	
	// Setup all necessery vars for checking
	if (el) {
		var id=el.getAttribute('cm_gid');
		var book=el.getAttribute('cm_abook');
		var g=group_find(abooks[book],id);
	}

	if(g.webmail){
		r.icon=ic_red; r.icon_text='Cannot drag & drop to webmail group'; // $$st_ct_dnd_adding$$			
		return r;
	}

	var cid=d.fromDiv.getAttribute('cm_cid');
	var abk_src=d.fromDiv.getAttribute('cm_abk');

#	dbg('*** bk='+abk_src+' -> bk2='+book+' ('+id+') g.isabook='+g.isabook+' g.is_group='+g.is_group);
	
	if(book==''&& g.name=='All Addresses'){
		r.icon=ic_red; r.icon_text=$('Cannot modify %s','All Addresses');
		return r;
	}
	if(!group_editable(g) && book!='User'){
		r.icon=ic_red; r.icon_text=$('Adressbook %s is readonly',book);
		return r;
	}

#	// Try and add to group in current abk
	if(book==abk_src){
		if(g.isabook || class_contains(el.firstChild,'selected') ||
					book=='User'&&g.name=='All Contacts'){
			r.icon=ic_red; r.icon_text=$('Already part of %s',g.name);	// Already part of %s group		$$st_ct_dnd_already$$
			return r;
		}
		r.icon=ic_green; r.icon_text='Adding to group '+g.name;		
		d.type='group';
		return r;
	}	
	
#	// try copy between addressbooks
	if(book!=abk_src){
		if(book==''&&g.name=='All Addresses'){
			r.icon=ic_red; r.icon_text=$('Cannot add to %s',g.name);	// Already part of %s group		$$st_ct_dnd_already$$
			return r;
		}
		var extra='';
		if(!g.isabook){
			extra+='group '+g.name+' in ';
		}
		if (g.name=='User'){
			extra+='personal addressbook';
		}else{
			extra+=book;
		}
		r.icon_text='Copy contact to '+extra;
		r.icon=ic_green;
		d.type='copy';
		return r
	}

	// right... so we have no idea as to validity...

||ifdef||_junk_||
	
    d.copy= (g&&g.shared&&group_editable(g));    
    if (g.webmail || (g.shared && !(d.c.shared||group_editable(g))) ) {

	if(!contact_editable(d.c)){
    	return '$$st_ct_dndbad$$';					// This type of contact cannot be organised in your personal addressbook<br>(includes shared, webmail and groups)
    }
	if(id=='all') return '$$st_ct_dnd_alreadyall$$';// Already part of All Contacts
	if(!g) return '$$st_ct_dnd_adding$$';			// Adding to group
	if(g.webmail) return '$$st_ct_dnd_noweb$$'		// Cannot modify webmail addresbook
	
	if(g.shared && !d.c.shared){
		if(group_editable(g))
			return 'Copy to shared addressbook';
		else
			return '$$st_ct_dnd_no_p2s$$';			// Cannot add personal contact to shared groups
	}else if(c.shared && !g.shared){
		return '$$st_ct_dnd_no_s2p$$';				// Cannot add shared contact to personal groups
	}else if (el && class_contains(el,'selected')){
		return $('$$st_ct_dnd_already$$',g.name);	// Already part of %s group
	}else{			
		return $('$$st_ct_dnd_adding2$$',g.name);	// Adding to group %s
	}
	
	dbg('QQQ abk_src='+abk_src+' cid='+cid+' gid='+gid+' abk_to='+abk_to);

	if(abk_to==abk_src){
		dbg('Actioning contact DND add to group ['+gid+']');
	}else{
		dbg('Actioning contact DND copy ['+gid+']');
	}
||endif||
	return r;		// => yes / no valid drop target		
}

||ifdef||_junk_||
function dnd2dst_OnDragOver_old(jc,o){
    var d = o.data;
    var el = ancestor_by_class(o.overElement, "cm_group");
	if (el) {
		var id=el.getAttribute('cm_gid');
		var book=el.getAttribute('cm_abook');
		var g=group_find(abooks[book],id);
	}
		
    d.copy= (g&&g.shared&&group_editable(g));    
    if (!el || !d.validStart || id=='all' || d.nodrag || g.webmail || (g.shared && !(d.c.shared||group_editable(g))) ) {
        if (d.toDiv) class_remove(dnd2_row2cursor(d.toDiv),'dnd_sel');
        d.toDiv = null;
	    dnd2_iconUpdate(d,true,undefined,dnd2_ToIconText(d.c,g,el,id));
        return;
    }
    dnd2_iconUpdate(d,true,undefined,dnd2_ToIconText(d.c,g,el,id));
    if (el == d.toDiv) return;
    if (d.toDiv) class_remove(dnd2_row2cursor(d.toDiv),'dnd_sel');
    if (el.id == d.currFid) {
        d.toDiv = null;
        return;
    }
    d.toDiv = el;
	class_add(dnd2_row2cursor(el),'dnd_sel');
}
||endif||
function dnd2dst_OnDragOver(jc,o){
    var d = o.data;
    var el = ancestor_by_class(o.overElement, "cm_group");	
	var v=dnd2_validity(el,d);
	dnd2_iconUpdate(d,v.icon,undefined,v.icon_text);
	if(v.icon!=ic_green){
        if (d.toDiv) class_remove(dnd2_row2cursor(d.toDiv),'dnd_sel');
        d.toDiv = null;
        return;
    }
    if (el == d.toDiv) return;
    if (d.toDiv) class_remove(dnd2_row2cursor(d.toDiv),'dnd_sel');
    if (el.id == d.currFid) {
        d.toDiv = null;
        return;
    }
    d.toDiv = el;
	class_add(dnd2_row2cursor(el),'dnd_sel');
}
function dnd2dst_OnDragOut(jc,o){
    var d = o.data, fld = d.toDiv;
    if (!d.validStart) return;
   	dnd2_iconUpdate(d,false);
    if (d.toDiv) class_remove(dnd2_row2cursor(d.toDiv),'dnd_sel');
    d.toDiv = null
}
function dnd2dst_OnDragDrop(jc,o){
    var d = o.data;
 	if (!d.toDiv || !d.validStart) return;
    if (d.toDiv) class_remove(dnd2_row2cursor(d.toDiv),'dnd_sel');

	var abk_src=d.fromDiv.getAttribute('cm_abk');
	var cid=d.fromDiv.getAttribute('cm_cid');
	var gid=d.toDiv.getAttribute('cm_gid');
	var abk_to=d.toDiv.getAttribute('cm_abook');

	dbg('QQQ abk_src='+abk_src+' cid='+cid+' gid='+gid+' abk_to='+abk_to);

	if(abk_to==abk_src){
		dbg('Actioning contact DND add to group ['+gid+']');
		cm_contact_add2group(abk_src,cid,gid)
	}else{
		dbg('Actioning contact DND copy ['+abk_to+':'+gid+']');
		contact_copy_one(abooks[abk_src].data[cid],abk_to,gid);
	}
    o.success = true
}

function dnd2_row2cursor(el){return el.firstChild.childNodes[2]}

function dnd_iconRemove(a) { 
	document.body.removeChild(a.parentNode);
};
function dnd1_iconCreate(d,count)
{
	var a=new_anchor('div','<div class="dnd_info"><span>'+$(ctl_opt_key(event)?'$$st_msgdnd_copying$$':'$$st_msgdnd_moving$$')+'</span> '+$('$$st_msgdnd_count$$',count,plural(count))+'</div>');
    d.drag_div = a.firstChild;
    d.style = d.drag_div.style;
    d.xoffset = Loc.isBidi ? d.drag_div.offsetWidth : 0;
    d.copy=ctl_opt_key(event);
    dbg('d.copy='+d.copy)
    return a.firstChild;
};
function dnd1_iconUpdate(d,ok,bad)
{
    if (d.validStart) {
        d.style.top = px(event.clientY + 20);
        d.style.left = px(event.clientX + (Loc.isBidi ? -10 : 10) - d.xoffset);
		if(ok){
			class_add(d.drag_div,"dnd_drop");
			class_remove(d.drag_div,"dnd_bad");
		}else if(bad){
#			// A slightly nasty test, but allows us to modify cursor without major changes to core DND code :-)
			if(document.body.style.cursor=='pointer'){
				class_remove(d.drag_div,"dnd_bad");
				class_remove(d.drag_div,"dnd_drop");
			}else{			
				class_add(d.drag_div,"dnd_bad");
				class_remove(d.drag_div,"dnd_drop");
			}
		}
		var copykey=ctl_opt_key(event);
		if(d.copy!=copykey){
			d.drag_div.firstChild.innerHTML = (copykey?'$$st_msgdnd_copying$$':'$$st_msgdnd_moving$$');
			d.copy=copykey;
		}
    }
};
function dnd2_iconCreate(d)
{
	var a=new_anchor('div','<div class="dnd_info"></div>');
    d.drag_div = a.firstChild;
    d.style = d.drag_div.style;
    d.xoffset = Loc.isBidi ? d.drag_div.offsetWidth : 0;
    return a.firstChild;
};
function dnd2_iconUpdate(d,icon,bad,txt)
{
    if (d.validStart) {
        d.style.top = px(event.clientY + 20);
        d.style.left = px(event.clientX + (Loc.isBidi ? -10 : 10) - d.xoffset);
		
		if(icon==ic_green){
			class_add(d.drag_div,"dnd_drop");	// green
			class_remove(d.drag_div,"dnd_bad");
		}else if (icon==ic_red){
			class_add(d.drag_div,"dnd_bad");	// red
			class_remove(d.drag_div,"dnd_drop");
		}else{
#			// A slightly nasty test, but allows us to modify cursor without major changes to core DND code :-)
			if(document.body.style.cursor=='pointer'){
				class_remove(d.drag_div,"dnd_bad");
				class_remove(d.drag_div,"dnd_drop");
			}else{			
				class_add(d.drag_div,"dnd_bad");
				class_remove(d.drag_div,"dnd_drop");
			}
		}
	}
	if (txt && d.drag_div) d.drag_div.innerHTML = txt;
};

# ****

function default_font_size()
{
	if (sw.is_popup)
		return sw_win.font_size;
	else
		return font_size;
}

function newmsg_refresh_allowed()
{
	if (sw.fld_id!="INBOX") return false;
	var sel=find_sel(true);
	if (sel && sel.length>1) return false;
	if (sw.search_input && sw.search_input.valid) return false;
	if (sw.nav_first>1) return false;
	return true;
}
function delayed_refresh(fn)
{
	if(!newmsg_refresh_allowed()) return false;
#	return true;
	setTimeout(function(){
			var nofocus;
			var sel=find_sel(true);
			var pending=find_pending();
			if(!sel || sel && sel.length==1)
				fn();
			for_each_msg(pending,'pending');
			if(isIE && pref.windows=='popup') nofocus=true;
			msglist_select(sel?sel[0]:first_message,U,nofocus);
		},120);
	return true;
}

function plural(len){
	return len>1?'s':'';
}
function set_from(node,val)
{
	node.value=val;
	node.nextSibling.innerHTML=encode_lt_gt(val);
}
var popup_spellcheck;
function spellchecker_said(o)
{
	if(!o || o.length==0) {
		set_status('$$st_spell_err_none$$','success');
		return;
	}
	var len=o.length;
	set_status($('$$st_spell_err$$',len,plural(len)),"info");
	
	if(!popup_spellcheck || popup_spellcheck==window)
		check_spelling_cb(o)
	else
		popup_spellcheck.check_spelling_cb(o);
}

function msg_from_editor(node)
{
	var txt;
	if(node.field_eframe.viewMode==2 && !node.is_popup)
		toggleMode(undefined,dge('etbar'+node.instance));

	if (node.sc){
#		// cleanup from spellchecker
		txt=node.sc.getTextToCheck()
	}else{
		txt=oddball_cleanup(node.field_eframe.contentWindow.document.body.innerHTML);
	}

	return txt;
}

function oddball_cleanup(txt)
{
#	Webkit browsers (safari etc) editor converts &nbsp; to high end characters, so convert back. OK to do for all browsers
#	if (isSafari);
	txt = txt.replace(/\u00A0/g, '&nbsp;');
#	Opera sends odd things like \r\r and \r which serverproceesing does not like, as \r characters get 
#	junked during serverside processing anyway lets just outright remove them for all browsers
	txt = txt.replace(/\r/g, '');

	return txt;	
}
//	just do a savedraft with integral spellcheck ;-)
function main_message_spellcheck(iid)
{
    var iid=sw.active.instance;
    var win=sw.active.field_eframe.contentWindow;
    
    var SC = Spell.getInstance(iid);
    if (!SC) {
        SC = new Spell(iid, win);
        sw.active.sc=SC;
		add_event(win.document,"mousedown", editor_mousedown);
		win.document.oncontextmenu=editor_contextmenu;
		document.oncontextmenu=editor_contextmenu;
		
#		win.document.onmousemove=function(e){dbg("++MOVE & forwarding target="+target(e).tagName);xx_menu.dispatchEvent(e)}
#		win.document.onmousemove=function(){dbg("++MOVE")}
#		win.document.onselectstart=function(){if(no_edit_contextmenu_once) return false;};
    }
	sw.run_spellcheck_once=true;
	do_save_draft(undefined,function(){sw.active.unsaved=false});
	
#	document.oncontextmenu=new Function("return false;")
}
function check_spelling_cb(o)
{
    var iid=sw.active.instance;
    var SC = Spell.getInstance(iid);
    if (!SC) return;
    
    SC.correctAll(true, null, true);
   
	SC.ajaxResultApply(o);
#	SC.g8(aa());			// Setup language related stuff
	SC.highlightWords();
}
function ed_spell_check_x1(e)
{
	var el=target(e);
	if (!class_contains(el,'mark')) return;
    var SC = Spell.getInstance(sw.active.instance);
//	SC.correctAll(true, null, true);
#	var el=xdoc.getElementById('misspell-1');
	return SC.showElementsMenu(el)
//	SC.showMenu(el)
}

function spellcheck_markup_remove(e)
{
    var SC = Spell.getInstance(sw.active.instance);
    if(!SC) return;

    var el = SC.bothRangeFn(e);
    var id = el ? el.id : null;

	SC.applyCorrection(el);

	// Just remove them all for now!!
//	SC.correctAll(true, null, true);
//	SC.applyCorrection(target(e),true);
}

function spellcheck_markup_removeall(flag)
{
	if(flag!=undefined && flag!=true) return;
    var SC = Spell.getInstance(sw.active.instance);
    if(!SC) return; 
    SC.correctAll(true, null, true);
}
function editor_mousedown(e)
{
	if(ed_spell_check_x1(e)){
		no_edit_contextmenu_once=true;
		stopEvent(e);
		return false;
	}
}

function spell_menu_click(e)
{
	if(!e) e=window.event; 
 	var SC = Spell.getInstance(sw.active.instance);
    if(!SC) return;

	var el=target(e);
	if(!el) return;
	if(class_contains(el,'shadow')) return;
	
	var mnu=ancestor_by_class(el,"xmenu");	
	var tag=el.tagName.toLowerCase();
	if(tag!='a') el=el.parentNode;

	switch(el.getAttribute("cmd")){
		case 'spell_menu_correct':
			SC.applyCorrection(mnu.el,true,el.innerHTML);
			break;
		case 'spell_menu_ignore':
			SC.applyCorrection(mnu.el,true);
			break;
		case 'spell_menu_learn':
			learn_word(mnu.el.innerHTML);
			SC.applyCorrection(mnu.el,true);
			break;
	}
	menu_hide2(mnu)
	no_edit_contextmenu_once=true;
	stopEvent(e);
	return false;
#    SC.correctAll(true, null, true);
}

var no_edit_contextmenu_once=false;
function editor_contextmenu(e)
{
	if(no_edit_contextmenu_once){
		no_edit_contextmenu_once=false;
		return false;
	}
}
function folder_click(e)
{
	var id;
	if(!e) e=window.event;
	var t=target(e);
	var row=ancestor_by_tag(t,'li');
	if (class_contains(row,'fake')){		
		fld_expand(undefined,undefined,row);
		if(row.childNodes.length==1){
			manage_folders(e);
		}
		return;
	}

	id=row.getAttribute('fld_id');
	if(id && id.length>0)	
		return F(id,row.getAttribute('fld_type'),undefined,undefined,undefined,undefined,ctl_and_cmd_key(e));	

	id=row.getAttribute('labelid'),row;
	if(id && id.length>0){	
		return L(id);	
	}
	
	id=row.getAttribute('srchid');
	if(id && id.length>0){	
		var txt;
		if(id=='star'){	
			txt='flag:'+id+' folders:recent';
		}else if(id=='label'){	
			txt='label:* folders:recent';
		}else if (id=='comment') {
			txt='comment:1';
		}else if (id=='custom') {
			txt=row.getAttribute('search_rule');
		}
		search_init(txt);
		F(sw.fld_id,0,0,false,true);
		return;
	}
	
}
function full_cursor2link(el)
{
	return el.childNodes[2].childNodes[0];
}

function learn_word(txt)
{
	queued_req_add( enQ, 'learn_word', function(){
		sndReq('cmd=spellcheck_learn,show&page=~result.js&new_word='+xescape(txt), function(chan){
			var success=actionReqJsStat(chan);
			if(success){
				set_status($('$$st_spell_learnt$$',txt),"success");
			}else{
				set_status('$$st_spell_learn_bad$$ ('+success_string+')','warning');
			}
		},ch[enQ]);
	});
}
function check_version(ver)
{
	if(ver==version||version==undefined) return true;
	set_status('$$st_stat_upg$$','warning');
	x_alert('$$st_dlg_upg$$');
	sw.upgrade_pending=true;
	update_ssb_status(-1);
	version=undefined;
	return false;
}


# Create a "jmsg" object ie. javascript message object that lasts until the message is successfully sent or message is discarded
# lives in the context of the main window even for popup windows so it does not need to cloned
function compose_jmsg(eml)
{
	var jmsg=new Object();
	jmsg.to=eml;jmsg.cc=[];jmsg.bcc=[];
	jmsg.sel_mids=[]
	jmsg.params=jmsg.subject=jmsg.msg_html=jmsg.cache_mid=jmsg.fld_id='';
	jmsg.action='compose';
	jmsg.send_mode=pref.send_mode!='auto'?pref.send_mode:'plain_text';
	return jmsg;
}
function jmsg_reset(jmsg)
{
	jmsg.cb=jmsg_check_ready;
	jmsg.msg_html='';
}
function sel_to_jmsg(sel, action)
{
	var jmsg=new Object();
	dbg('sel_to_jmsg '+action);

#	// Automatically switch "forward" to "forward attach" for multiple messages
	if (sel.length>1 && action=='forward') action='forward_attach';

#	// The bare minimum information we need to identify a message :-)
	jmsg.action=action;
	jmsg.fld_id=sw.fld_id;	
	jmsg.fid=sw.fid;	
	jmsg.fld_type=sw.fld_type;	
	jmsg.cache_mid=sel[0];
	jmsg.sel_mids=sel;
	
# 	// Now actually get the message details if we have it
	if(!sw_cache[cache_id(jmsg.fid,jmsg.cache_mid)]){
		dbg('don\'t actually have the source message yet so setting up callback to poll later');
		jmsg.cb=jmsg_check_ready;
		return jmsg;
	}

	if (action=='view') return jmsg;

	return jmsg_complete(jmsg);
}
function jmsg_check_ready(jmsg)
{
	if(!sw_cache[cache_id(jmsg.fid,jmsg.cache_mid)]) return false;
	if(jmsg.action=='view') return true;
	jmsg_complete(jmsg);
	return true;
}
function jmsg_complete(jmsg)
{
	var action=jmsg.action;
	qmsg=sw_cache[cache_id(jmsg.fid,jmsg.cache_mid)];
	if(!qmsg) {alert('msg error, should never get here!!');return jmsg;}

	var from=cloneObject(qmsg.data['from']);
	var to=cloneObject(qmsg.data['to']);
	var cc=cloneObject(qmsg.data['cc']);
	var bcc=cloneObject(qmsg.data['bcc']);
	var reply_to=cloneObject(qmsg.data['reply_to']);

	jmsg.related=qmsg.data['related'];
	jmsg.send_mode=(pref.send_mode=='auto')?qmsg.data['send_mode']:pref.send_mode;
	jmsg.subject=qmsg.data['subject'];
	jmsg.date=qmsg.data['date'];

	jmsg.nattach=val_int(qmsg.data['attachments']);
	
#	// Work out what part of the old message body to display
	if(action=='edit' || action=='redirect'){
		jmsg.msg_html=qmsg.msg_html;
	}else if(action=='forward_attach'){
		jmsg.msg_html='';
	} else{
		if((action=='reply') && !pref.no_short_reply_hdr){
			jmsg.msg_html=
				date_reformat1(jmsg.date)+' '+contact_string_short(text2contact(clean_whitespace(from[0])))+' wrote: '
				+(pref.no_replycolor?'':'<blockquote type="cite">')
#				+'<br><br>'
				+qmsg.msg_html
				+(pref.no_replycolor?'':'</blockquote><br>');
		}else{
			jmsg.msg_html=
				(pref.no_replycolor?'':'<blockquote type="cite">')
				+'$$st_txt_hdr_orig$$'
				+' <br><b>$$st_hdr_subject$$</b> '+encode_lt_gt(jmsg.subject)
				+' <br><b>$$st_hdr_from$$</b> '+rcpts_as_html(from)
				+' <br><b>$$st_hdr_to$$</b> '+rcpts_as_html(to)
				+(cc.length>0 ? ' <br><b>$$st_hdr_cc$$</b> '+rcpts_as_html(cc) : '')
				+' <br><b>$$st_hdr_date$$</b> '+jmsg.date
				+'<br><br>'
				+qmsg.msg_html
				+(pref.no_replycolor?'':'</blockquote><br>');
		}
	}
#	// Now work out addressing	
	if (action=='redirect') to=[];
	jmsg.cc=[];
	jmsg.bcc=[];	
	if (action=='reply' || action=='reply_all'){
		if (jmsg.subject.substring(0,3).toLowerCase()!="re:") jmsg.subject='Re: '+jmsg.subject;
		jmsg.to=(jmsg.fld_type==enSent?to:reply_to);
		if(action=='reply_all'){		
			jmsg.cc=to;
			if(cc.length>0) jmsg.cc=jmsg.cc.concat(cc);
		}
	}else if ((action=='forward') || (action=='forward_attach')) {
		if (jmsg.subject.substring(0,4).toLowerCase()!="fwd:") jmsg.subject='Fwd: '+jmsg.subject;
		jmsg.to=[];
	}else{
#		Re-edit a draft or other message etc
		jmsg.to=to;
		jmsg.cc=cc;
		jmsg.bcc=bcc;
		jmsg.not_new=true;
		jmsg.edit_uid=cache_id(jmsg.fid,jmsg.cache_mid);
	}
	return jmsg;
}


// See [function ajax_send]
// Used to be [function msg_for_sending(node)]

function jmsg_update(node)
{
#	Make sure allocs are done in the context of the main window	
	if(sw.is_popup) {
#		debugger;
#		if(node.field_eframe.viewMode==2)
#			toggleMode(undefined,dge('etbar'));
		return sw_win.jmsg_update(node);
	}

	var jmsg=node.jmsg;
	if (!jmsg) {alert('badness');return;}
	
	jmsg.to=fancy_edit_value(node.field_to);
	jmsg.cc=fancy_edit_value(node.field_cc);
	jmsg.bcc=fancy_edit_value(node.field_bcc);
	jmsg.priority=node.field_priority.value;
	jmsg.confirm=node.field_confirm.value;
	jmsg.encrypt=node.field_encrypt.value;
	jmsg.subject=node.field_subject.value;
	jmsg.msg_html=msg_from_editor(node);

#	// Possibly want to make this selectable somehow	old: [node.field_from.value]
	jmsg.from=[work_out_from()];	
	jmsg.params='&from='+rcpts_as_param(jmsg.from)+'&priority='+jmsg.priority+'&confirm='+jmsg.confirm+'&encrypt='+jmsg.encrypt;
	
#	// Easiest to ensure this is done here
	if(jmsg.attach_ids||(jmsg.attach_ids_mpr&&(jmsg.attach_ids_mpr.length>0))){
		jmsg.params+='&attach_mid='+jmsg.attach_mid;
		if(jmsg.attach_ids){
			jmsg.attach_ids=cloneObject(jmsg.attach_ids);
			if(jmsg.attach_ids.length>0){
				jmsg.params+='&attach_ids='+jmsg.attach_ids.join(',');
			}
		}
		if(jmsg.attach_ids_mpr&&(jmsg.attach_ids_mpr.length>0)){
			jmsg.params+='&attach_ids_mpr='+jmsg.attach_ids_mpr;
		}
	}
	if (jmsg.edit_uid){
		jmsg.params+='&edit_uid2='+jmsg.edit_uid;
	}
	jmsg.params+='&send_mode='+jmsg.send_mode;

	// Turn this into or conditions??
	jmsg.from_popup=node.is_popup;
	jmsg.node=node;
	
	return jmsg;
}
function main_window_check(node)
{
	var ok;
#	// try catch based check (I can't think of anything nicer for now) 
	try{var dummy=node.jmsg.to; ok=true;}catch(e){ ok=false;}

	if(!ok || !window.opener || window.opener.closed){
		alert('WARNING: Main SurgeWeb window unavailable - you must leave this open while you are using surgeweb.\n\n Copy and paste message text from here to save your work.');
		return false;
	}
	
	return true;
}
function read_attached_msg(part)
{
	alert('want to show '+part);
#	show_message(??? , part);
}
// cmd=show&page=~msg.js&msg_id=110267&fld_id=INBOX&sid=2&if=ajax

function jmsg_display_class(jmsg){
	return (jmsg.action=='redirect'?'do':'no')+'redirect';
}

function compare_folders(fld1,fld2)
{
	if(fld1==fld2) return true;
	x_alert('You must have the '+fld1+' folder selected instead of '+fld2+' folder.');
	return false;
}
function bookmarking_init()
{
	if(pref.devt_test=='nounload' || isChrome) return;

	window.onbeforeunload=function(e){
#		if(!sw.closing && class_contains(sw.active,'message'))
		if(!sw.closing && sw.active.unsaved)
			return 'Your message will be lost.';
	}
}
function fancy_edit_hidden(el)
{
	el=ancestor_by_class(el,'compose_hdr_row');	
	return class_contains(el,'hidden');
}
function focus_next_surgeweb_edit_ctl(el)
{
	var o=sw.active;
	var next;
	if(el==o.field_to)
		next=o.field_cc;
		
	if((el==o.field_cc) || (next==o.field_cc && fancy_edit_hidden(o.field_cc)))
		next=o.field_bcc;

	if((el==o.field_bcc) || (next==o.field_bcc && fancy_edit_hidden(o.field_bcc)))
		next=o.field_subject;

	if(el==o.field_subject)
		next=o.field_eframe.contentWindow;

	if(!next) return;

	next.focus();	
}

#var q=[]
#for (var i=0;i<100;i++)
#	q[i]='012345678901234567890123456789012345678901234567890123456789012345678901234567890123456789';

function do_test()
{
#	benchmark_begin('1');
#	for (var i=1;i<10000;i++)
#		dbg(q[1]+q[2]+q[3]+q[4]+q[5]+q[6]+q[7]+q[8]+q[9]+q[0]);
#		dbg();
#	alert(benchmark_end('1'));
	
}
# Do one of several spam processing action: notspam, once, spam, block
function spam_info(type,fld,mid)
{
	if(!class_contains(sw.active,'fldmsg')){
		alert("sorry only available from preview pane for now");
		return;
	}
	if(sw.is_popup){
		sw_win.spam_info(type,fld,mid);
	}
	var sel=find_sel(true);
	if(sel.length>1){
		x_confirm('$$st_spam_multi$$',function(n){
			if(!n) return;
			spam_info_step2(type,sel);
		});
		return;
	}
	var sel=make_sel(fld,mid);
	spam_info_step2(type,sel);	
}
function spam_info_step2(type,sel)
{
	ajax_spam_rating(sel,type,function(){});
	
#	// Do stuff dependant on location
	if(class_contains(sw.active,'fldmsg')){
		// preview
		no_msg_sel();
	}else if(sw.is_popup){
		// popup
	}else{
		// inline	
	}
}

function partial_update_results(o)
{
	partial_updates = o;
}
function folder_refresh_results()
{
	folder_refresh=true;
}

function misc_init(){
	search_init(undefined,pref.search_type);
	
	Dbg.report_cb=function(txt){
		x_prompt("This will send matching browser and server SurgeWeb debug logs to marijn@netwinsite.com. Please add a comment to identify the reason for sending this report :","comment",function(val){
			if (!val) return;
			var jmsg=compose_jmsg(['marijn@netwinsite.com']);
			jmsg.params='&to='+rcpts_as_param(jmsg.to)+'&subject='+xescape('SurgeWeb fault report')+'&attach_debug_log=true';
			jmsg.report=true;
			jmsg.msg_html=	'Fault reported by: '+work_out_from()+'<br>'+
							'Comment:'+val+'<br>'+
							'<br>'+
							'Surgweb browser log:<br>'+
							txt;
			ajax_send(jmsg);
		});
	}
	if('true'=='||online_status_dev||'){
		var el
		el=dge('personal_info'); Drag.init(el, el);
		el=dge('oli1'); Drag.init(el, el);
		el=dge('oli2'); Drag.init(el, el);
		el=dge('oli3'); Drag.init(el, el);
	}
}

# defined fuctions this way else some browsers do not allow you to call them
var map_sw_2_core, map_core_2_sw, map_ctls_to_ctl0, ctl0_mapping, ctl_text, ctl2_allow, extra_info;
var usercgi_status, usercgi_raw, usercgi_working, usercgi_messages=['',''];
var opt_xx=['respond','fwd_early','filter','whitelist','spam','unknown','fwd_late'];

function usercgi_summary()
{
#return;
#debugger;
	usercgi_status={'respond':'(unknown)', 'fwd_early':'(unknown)', 'filter':'(unknown)', 
					'whitelist':'(unknown)', 'spam':'(unknown)', 'unknown':'(unknown)',	'fwd_late':'(unknown)'};

	for(var i=0;i<opt_xx.length;i++){
		el=dge('filt_'+opt_xx[i]);
		if(el) el.innerHTML=usercgi_status[opt_xx[i]];
	}
	
	queued_req_add( enQ, 'usercgi_summary', function(){
		var url=backend+'cgi/user.cgi?cmd=auto_login%26lcmd=user_summary_info%26show=sw_summary.js%26utoken='+utoken;
		sndReq('cmd=proxy&sid='+sid+'&add_auto_login=true&url='+url, function(chan){
#			// check validity of response... 
			var success=actionReqJsStat(chan);
			apply_summary_info();
		},ch[enQ]);
#		cgibase=tmp;
	});
}
#			var usercgi_status={
#					'respond':'ENABLED', 'fwd_early':'UNKOWN', 'filter':'STATUS', 'whitelist':'STATUS',
#					'spam':'<font color="green">ENABLED</font>', 'unknown':'<font color="red">DISABLED</font>', 'fwd_late':'STATUS'};

function set_ctl0(event,ctl)
{
	var onestep=ctl.value;

	ctl_dynamic_select(ctl,ctl0_options(ctl.value),ctl_text);
	ctl.value=onestep;
	ctl_dynamic_info(ctl);
	
	var state=ctl0_mapping[onestep];	
	map_sw_2_core(state[0],state[1],usercgi_working);
	
	var w=usercgi_working;
	var url=backend+'cgi/user.cgi?cmd=auto_login%26lcmd=user_spam_save%26combine_spam_friends=true%26lcmd_ex=user_summary_info%26show=sw_summary.js';
	url += '%26friend_mode='+w.friend_mode+'%26friend_smite='+w.friend_smite+'%26recent_out_auto='+w.recent_out_auto
			+'%26spam_subject='+w.spam_subject+'%26spam_body='+w.spam_body+'%26spam_bounce='+w.spam_bounce
			+'%26spam_ddpriv='+w.spam_ddpriv+'%26spam_ddfrom='+w.spam_ddfrom+'%26spam_store='+w.spam_store+'%26spam_vanish='+w.spam_vanish;

	sndReq('cmd=proxy&sid='+sid+'&add_auto_login=true&url='+url, function(chan){
		var success=actionReqJsStat(chan);
		apply_summary_info();
	})
}

function apply_summary_info()
{
	var val;
	var lookup=[];
#	Do any complicated workings out...

	if(usercgi_status['respond']=='not available'){
		var txt=usercgi_messages.join(', ');
		if(txt.length<=2) txt='unknown error';
		set_status('$$st_stat_usercgi_bad$$ - '+txt,'warning');
		for(var i=0;i<opt_xx.length;i++){
			el=dge('filt_'+opt_xx[i]);
			if(el) el.innerHTML='(not available)';
		}
		return;
	}

	if(true){
		usercgi_working=cloneObject(usercgi_raw);	
		var state=map_core_2_sw(usercgi_working);
		var onestep=map_ctls_to_ctl0(state);
		ctl=dge("spam_onestep");
		if(ctl){
			ctl_dynamic_select(ctl,ctl0_options(onestep),ctl_text);
			ctl.value=onestep;
			ctl_dynamic_info(ctl);
		}
		switch(onestep){
			case 'disabled': 		val='disabled';break;
			case 'little_spam': 	val='markonly';break;
			case 'little_spam2':
			case 'lots_spam':
			case 'lots_spam2': 		val='enabled';break;					
			case 'child_account': 	val='kidsafe';break;
			default:				val='custom';break;
		}
		if(usercgi_working.spam_store>0 || usercgi_working.spam_vanish>0)
			val='warn';
		lookup['spam']=val;

		if(usercgi_working.friend_mode!='disabled'){
			if(usercgi_working.recent_out_auto=='checked')
				val='enabled';
			else
				val='part';
		}else{
			val='disabled';
		}
		lookup['whitelist']=val;

		switch(usercgi_working.friend_mode){
			case 'smite':
			case 'ask':	val='enabled'; break;
			case 'safe':val='kidsafe';break;
			default: val='disabled';break;
		}
		lookup['unknown']=val;				
	}
	for(var i=0;i<opt_xx.length;i++){
		if (!usercgi_status || !usercgi_status[opt_xx[i]]) continue;
		if(opt_xx[i]=='whitelist' || opt_xx[i]=='spam' || opt_xx[i]=='unknown'){
			val=usercgi_status[opt_xx[i]][lookup[opt_xx[i]]];
		}else{
			val=usercgi_status[opt_xx[i]];
		}
		el=dge('filt_'+opt_xx[i]);
		if(el) el.innerHTML=val;
	}
	if(dge('forward_early')){
		if(usercgi_status['use_late']=='checked'){

			class_add(dge('forward_early'),'hidden');
			class_remove(dge('forward_late'),'hidden');
		}else{
			class_add(dge('forward_late'),'hidden');
			class_remove(dge('forward_early'),'hidden');
		}
	}
	extra_info('extra_info2',usercgi_working);
	if(usercgi_status['g_imap_friends']=='false')
		class_remove(dge('warning_g_imap_friends'),'hidden');
}
function ctl0_options(val)
{
	var arr=['disabled','little_spam','little_spam2','lots_spam'];
	if (val=='child_account' || val=='custom') arr.push(val);
	return arr;
}
function newpass(pass)
{
	sndReq('cmd=session_update,show&page=~result.js&newpass='+xescape(pass), function(chan){
		var success=actionReqJsStat(chan);
		if(!success){
			set_status('$$st_stat_passwd_bad$$','warning');
		}
	});
}

function cur_quota(o)
{
	if(sw.is_popup) return sw_win.cur_quota(o);
	
	var refresh=false;
	if(!sw.quota || sw.quota.pct!=o.pct) refresh=true;
	sw.quota=o;
	if (refresh) app_menu('mail',dge('app_menu_mail'));
}

# Also defined in surgemail source code (and may still be some hardcoded numbers in the source)
var enFldInbox=1, enFldDrafts=2, enFldSent=3, enFldTrash=4, enFldUser=5, enFldSpam=6;

# Active Selection handling code locations 
# n retrieve_msg
# sw.search_type
# sw.multiple
# show_thread > search_init > do_stype
# search_keyup > do_search_folders > F > switch_selfld
# onclick > do_search_folders > F > switch_selfld


# OSX colors: blue color="#144fae" | green color="#006312" | brown color="#540000"
# TB colors: blue color="#0000ff" | brown color="#800000" | blue/green color="#008080" | purple color="#800080" | green color="#008000"

function quote_styles()
{
	return 	' .sw_message blockquote{margin-left:5px;padding-left:5px;border-left:2px solid #144fae;color: #144fae;}\n'+
			' .sw_message blockquote blockquote{border-left:2px solid #006312;color: #006312;}\n'+
			' .sw_message blockquote blockquote blockquote{border-left:2px solid #8e5656;color: #8e5656;}\n'+
			' .sw_message blockquote blockquote blockquote blockquote{border-left:2px solid #888;color: #888;}\n';
}

function quote_breakout(e)
{
	var el, ret, sel;
	if(pref.no_replycolor) return false;

	var xwin=get_edit_win();
	var xdoc=xwin.document;

	if(isIE){
		el=selectedElementIe(xdoc);
		ret=quoteBreakoutIe(xdoc,el);
	}else{	
		sel=selectedElementStd(xwin);
		ret=quoteBreakoutStd(xwin,sel)
	}
	return ret;	
}

function selectedElementIe(xdoc)
{
	var r,id,el;
	r=xdoc.selection.createRange();
	id=uniqueId();
	r.pasteHTML('<span id="'+id+'"></span>');
	el=xdoc.getElementById(id);
	el.id='';
	return el;
};
function selectedElementStd(xwin)
{
	var el,frag,sel,mysel;
	sel=get_selection_std(xwin)
	if(!sel) return null;
	mysel=get_range_std(sel);
	if(mysel.start_el.nodeType==1 && mysel.start_el.tagName=="BLOCKQUOTE"){
		frag=mysel.start_el.childNodes[mysel.offset];
		el=xwin.document.createTextNode('');
		mysel.start_el=frag.appendChild(el);
		mysel.offset=0;
	}
	return mysel;
};

function quoteBreakoutIe(xdoc,el)
{
	var pivot,g,r,frag;
	pivot=quote_root(el);
	if(!pivot) return false;
	frag=el.cloneNode(false);
	frag=dom_split(el,frag,pivot);
	special_insert_before(frag,pivot);
	g=xdoc.createElement('div');
	pivot.parentNode.insertBefore(g,frag);
	g.innerHTML='&nbsp;';
	r=xdoc.selection.createRange();		// 
	r.moveToElementText(el);
	r.move('character',2);
	r.select();
	g.innerHTML='';
	r.pasteHTML('');	
	return true;
};
function quoteBreakoutStd(xwin,sel)
{
	var el,pivot,i,frag;
	if (!sel) return false;
	el=sel.start_el;
	pivot=quote_root(el);
	i=false;
	if(pivot){
		if(el.nodeType==3){
			frag=el.splitText(sel.offset);
		}else{ 
			dbg('warnign non DOM node quote breakout - may not work');
			i=true;
		}
	}
	// deal with not landing on a textNode by adding textnodes etc
	if(!pivot)return false;
	frag=dom_split(el,frag,pivot);
	special_insert_before(frag,pivot);
	el=xwin.document.createElement('div');
	el.innerHTML='&nbsp;';
	pivot.parentNode.insertBefore(el,frag);
	xwin.getSelection().collapse(el,0);
	return true;
};


function quote_root(node)
{
	var pivot=null;
	for(var el=node.parentNode;el;el=el.parentNode)
		if(el.tagName=='BLOCKQUOTE') 
			pivot=el;
	return pivot;
}

var unique_id_n=0;
function uniqueId(){
	return 'swq_'+unique_id_n++;
}

function special_insert_before(b,a)
{
	a.parentNode&&a.parentNode.insertBefore(b,a.nextSibling)
}
function get_selection_std(xwin)
{
	if(xwin.getSelection){
		return xwin.getSelection();
	}else{
		var xdoc=win.document;	
		return xdoc.selection || xdoc.getSelection && xdoc.getSelection();
	}
}
function get_range_std(b)
{
	var r,c=false;
	if(b.createRange){
		try{
			r=b.createRange()
		}catch(d){
			return null
		}
	} else if(b.rangeCount){
		if(b.rangeCount>1){
			dbg('BAD: multiple ranges defined - unhandled')
			return null;
		}else{
			r=b.getRangeAt(0);
		}
	} else {
		return null;
	}
	if(r.addElement) {
		dbg('BAD: unhandled case');
		return null;
	}
	var ret={};
	ret.start_el=r.startContainer;
	ret.offset=r.startOffset;
	return ret;
}


# -----

function set_sendmode_html()
{
	if(!sw.active.field_send_mode) return;
    var el=sw.active.field_send_mode;
	if(pref.send_mode!='auto') return;
	
	el.innerHTML="Html"
    sw.active.jmsg.send_mode='html';
}
function toggle_sendmode()
{
	if(!sw.active.field_send_mode) return;
    var el=sw.active.field_send_mode;	
	var jmsg=sw.active.jmsg;
	if(jmsg.send_mode=='html'){
		el.innerHTML="Plain text"
		jmsg.send_mode='plain_text';
	}else{
		el.innerHTML="Html"
		jmsg.send_mode='html';
	}
}


function toggle_encrypt_menubar(el)
{
    var enc=sw.active.field_encrypt;
	encrypt_set(el,enc,(enc.value==''?'surgevault':''));
}
function toggle_encrypt_select(el)
{
	encrypt_set(dge('send_encrypt'),el,el.value);
}
function encrypt_set(el_icon,el_select,type)
{
	if(!type || type==''){
		el_select.value='';
		class_remove(el_icon,'surgevault');
		el_icon.title='SurgeVault encryption : not encrypted';
	}else{
		el_select.value='surgevault';
		class_add(el_icon,'surgevault');
		el_icon.title='SurgeVault encryption : ENCRYPTED';
	}
}
function row_shown(el)
{
	var po=ancestor_by_class(el,'compose_hdr_row');
	return !class_contains(po,'hidden'); 
}
function save_sticky(sticky)
{
	var val,js_val;
	if(!sw.active.field_sticky.checked && !sticky) return;
	if(sticky && !sticky.checked){
		js_val=undefined;
		val='';
	}else{
		js_val=[row_shown(sw.active.field_cc),row_shown(sw.active.field_bcc),row_shown(sw.active.field_priority),sw.active.field_priority.value,sw.active.field_confirm.value,sw.active.field_encrypt.value,sw.active.field_signature.value];
		val='['+js_val[0]+','+js_val[1]+','+js_val[2]+',"'+js_val[3]+'","'+js_val[4]+'","'+js_val[5]+'","'+js_val[6]+'"]';
	}

	if(sw.is_popup)
		return sw_win.save_sticky_frompopup(js_val,val)
	pref.compose_sticky=js_val;
	ajax_pref_save('pref_compose_sticky='+val);
}
function save_sticky_frompopup(js_val,val)
{
	pref.compose_sticky=cloneObject(js_val);
	ajax_pref_save('pref_compose_sticky='+val);
}
function signature_dbgout(txt)
{
	return txt.length+':'+encode_lt_gt(txt);
}
function signature_select(el,val,xwin)
{
	if(el) el.innerHTML=val;
	if(xwin) xwin.orig_sig=val;
	dbg('** SIGSET xwin.orig_sig='+signature_dbgout(val))
}
function toggle_signature(ctl)
{
	var xwin=get_edit_win();
	var xdoc=xwin.document;
	var el=xdoc.getElementById('editor_signature');
	if(!el){
		var i,frag;
		for (var i=0;i<3;i++){
			frag=xdoc.createElement('br');
			xdoc.body.appendChild(frag);
		}
		el=xdoc.createElement('div');
		el.id='editor_signature';
		xwin.orig_sig='';
		xdoc.body.appendChild(el);
	}
	dbg('*** SIGCHANGE ['+signature_dbgout(xwin.orig_sig)+'] ['+signature_dbgout(el.innerHTML)+']')
	x_confirm('Signature text in document has been edited. Replace?',function(n){
		if(!n) return;
		var val=(ctl.value==''?'':signature['default']);
		signature_select(el,val,xwin);
	}, sametext_nc(xwin.orig_sig,el.innerHTML));
}

function signature_dlg(type)
{
	var cmd='cmd=show&page=signature.htm&sid='+sid;
	txt='Edit Signature(s)';		
	
	x_custom_dlg2(txt,dialog_iframe(cgibase+cmd),
		function(btn){
			ie_fixfocus();
			usercgi_summary();
	}, U, {'tall':true,'wide':true});
}

function dialog_iframe(url)
{
	return '<iframe src="'+url+'" style="width:100%;height:'+px(ClientHeight()*0.9-100)+'"></iframe>'
}

function get_edit_win()
{
	return sw.active ? sw.active.field_eframe.contentWindow : document.getElementById('eframe1').contentWindow;
}

function ed_insert_smarts()
{
	var xwin=get_edit_win();
	var xdoc=xwin.document;
	if(isIE){
		el=selectedElementIe(xdoc);
	}else{	
		sel=selectedElementStd(xwin);
		el=sel.start_el;
		if(el.nodeType==3){
			el=el.splitText(sel.offset);
		}
	}
	var type='link';
	if (type=='img'){
		var frag=document.createElement('img');
		frag.src='http://netwinsite.com/img2/box_surgemail.jpg';
		el.parentNode.insertBefore(frag,el);
	}else if (type=='link'){
		var frag=document.createElement('a');
		frag.href='http://netwinsite.com';
		frag.innerHTML='Link Description';
		el.parentNode.insertBefore(frag,el);
	}		
	return true;
}


function tweak_ie7_msglist(el)
{
	var row, rows, labels, icons, i, w;
	rows=el.getElementsByTagName('tr');
	for(row=0;row<rows.length;row++){		
		labels=row_to_labels(rows[row]);
		icons=labels.previousSibling;
		for(i=0,w=0;i<icons.childNodes.length;i++) w+=icons.childNodes[i].offsetWidth;
		icons.style.width=px(w);
		for(i=0,w=0;i<labels.childNodes.length;i++) w+=labels.childNodes[i].offsetWidth;
		labels.style.width=px(w);
	}

}

function date_reformat1(txt)
{
	var parts=txt.split(' ');
	var day=parts[0].split(',');
	var tstart=(parts[2]==''?3:2);
	return 'On '+day[0]+' '+parts[1]+' at '+parts[tstart]+(parts.length-1>tstart?(' '+parts[tstart+1].toLowerCase()):'')+',';
}

function preview_to_body(el)
{
	return el.childNodes[1];
}

#function cxx_image(){
#	return 'background:url(data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAAsAAAALCAYAAACprHcmAAAAoElEQVR42pWRQQ7CIBBFuZsn8BJezAN4BI/goqx0p4lpIwtNaVIowy8zIKmr1kl+/v/DYzVKpTmezliT+oJbRj78DXuKmELEbn/AJBnwpfvSK2xdRO8AO0IA7uz9WPZuARsbYYaIVxGDZqDa+a3C9zdlfTLIOXvEI2VWhW+GRAzkHGq/ll5h3QboLqklNCk3HUnW7LJfwJdnWNXPYbZccAaPd5VkvusvLAAAAABJRU5ErkJggg==)';
#}

var menu_icon;

function cxx_mouseover(e)
{
	var t=target(e);
	if(!class_contains(t,'rcpt')) return;

	if(menu_icon/* && menu_icon.parentNode!=t*/)
		hide_soon(menu_icon,true);
	
	var el=document.createElement('img');
	el.src='data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAAsAAAALCAYAAACprHcmAAAAoElEQVR42pWRQQ7CIBBFuZsn8BJezAN4BI/goqx0p4lpIwtNaVIowy8zIKmr1kl+/v/DYzVKpTmezliT+oJbRj78DXuKmELEbn/AJBnwpfvSK2xdRO8AO0IA7uz9WPZuARsbYYaIVxGDZqDa+a3C9zdlfTLIOXvEI2VWhW+GRAzkHGq/ll5h3QboLqklNCk3HUnW7LJfwJdnWNXPYbZccAaPd5VkvusvLAAAAABJRU5ErkJggg==';
	el.style.position='absolute';
	el.style.left=px(t.offsetLeft + t.offsetWidth - 11)
	el.style.top=px(t.offsetTop-1);
	el.onmousedown=cxx_action_click;
	el.className='qqq';
	t.appendChild(el);	
	menu_icon=el;
}
function cxx_mouseout(e)
{
	var t=target(e);
	dbg('HIDE 1 [parent]'+el_info(t.parentNode))
	dbg('HIDE 1 [el]'+el_info(t))
	if(!class_contains(t,'rcpt')){
		dbg('HIDE 2')
		return;
	}
	if(class_contains(t.parentNode,'rcpt')) {
		dbg('HIDE 3 *************')
		return;
	}
	dbg('HIDE 4')


	if(t.childNodes.length>1){
		dbg('HIDE 5')
		hide_soon(t.childNodes[1]);
		
	}
}
function hide_soon(el,now)
{
	if(!el||!el.parentNode) return;
	if(!now) return setTimeout(function(){hide_soon(el,true)},1000);

	el.parentNode.removeChild(el);
	menu_icon=null;
}

function cxx_action_click(e)
{
	if(!e) e=window.event;
	rcpt_contact=target(e).parentNode;
	do_menu_show('context_menu_rcpt',e,undefined,undefined,{cursor:true})
}

||ifdef||_junk_||
//rcpt_mousedown
addEventHandler(document.body, "beforepaste", reroutePasteEvent);
var rp={};
function reroutePasteEvent() 
{
  if (rp.capturingPaste || window.opera) return;
  rp.capturingPaste = true;
  var te = document.createElement("TEXTAREA");
  te.style.position = "absolute";
  te.style.left = "-500px";
  te.style.width = "10px";
  te.style.top = "10px";
  document.body.appendChild(te);
#  parent.focus();
  te.focus();

  var self = this;
  setTimeout(function() {
	rp.capturingPaste = false;
	rm.win.focus();
//	if (self.selectionSnapshot) // IE hack
//	  self.win.select.selectCoords(self.win, self.selectionSnapshot);
	var text = te.value;
	if (text) rp.replaceSelection(text);
	removeElement(te);
  }, 10);
}
||endif||


function compat_warn()
{
	if(pref.devt_test=='nodnd') sw.dnd_disabled=true;
	if(isChrome3){
		x_custom_dlg('Chrome 3.0 has bugs that may result in odd surgeweb behaviour if drag &amp; drop is enabled. We recommend you use Chrome 4.0, IE, Firefox, or Safari.',
					 'For more information see: <a href="http://netwinsite.com/surgeweb/help/browser_bugs.htm" target="_popup">browser issues</a>',
			function(btn){
				if(!btn) {
					sw.dnd_disabled=true;
					return;
				}
				msgdnd_init();
			},
			function(){
				var o;
				o=dge('dlg_ok'); o.style.width=px(150); o.value='I understand, continue';					
				o=dge('dlg_cancel'); o.style.width=px(150); o.value='Disable drag & drop';
			}
		);
	}
}

var keywords=[];
var kw_id=0;
function refresh_ad()
{
	var el,tmp,url,txt;
	if(!pref.ad1_updates) return;
	el=dge('right_column');
	if(!el) return;
	el=el.getElementsByTagName('iframe');	
	if(!el || el.length==0) return;

	if(!sw.google_ads_url){
		sw.google_ads_url=el[0].src;
		keywords=pref.ad1_keywords.split(',');
	}

	if(pref.ad1_updates=='update'){
		url=sw.google_ads_url;
	}else{
		if(pref.ad1_updates=='target_subject' && sw.google_ads_target){
			txt=xencode(sw.google_ads_target);
			sw.google_ads_target=null;
		}else {
			if(keywords.length) {
				txt=keywords[kw_id++];
				if(kw_id>keywords.length) kw_id=0;
			}else{
				txt='surgeweb&dt=';
			}
		}
		dbg('** Trying to target google ad to:['+txt+']');
		url=sw.google_ads_url.replace(/surgeweb&dt=/,txt+'&dt=');
	}
	el[0].src=url+'&'+mtime();
	return true;
}
function set_ads_targeted(txt)
{
	sw.google_ads_target=txt;
}


function select_lang(input)
{
	if(input.value!='more...') return;
	x_confirm('$$st_lang_showall$$', function(n){
		if(!n) return;
		do_options(true);
	});	
}
